/*
MICROSOFT SOFTWARE LICENSE TERMS
MICROSOFT AZURE MAPS WEB SDK

These license terms are an agreement between you and Microsoft Corporation (or one of its affiliates). They apply to the software named above and any Microsoft services or software updates (except to the extent such services or updates are accompanied by new or additional terms, in which case those different terms apply prospectively and do not alter your or Microsoft’s rights relating to pre-updated software or services). IF YOU COMPLY WITH THESE LICENSE TERMS, YOU HAVE THE RIGHTS BELOW.  BY USING THE SOFTWARE, YOU ACCEPT THESE TERMS.

1. INSTALLATION AND USE RIGHTS.
  a) General. You may install and use any number of copies of the software to develop and test your applications.
  b) User Region Parameters. The software will allow you to select from a View list to set the map view within your application for a given customer. By default the View parameter (also referred to as “user region parameter” is set to “Unified”.  Countries/Regions that are not on the View list will default to the “Unified” View. It is your responsibility to determine the location of your users, and then set the View parameter correctly for that location. The View parameter must be used in compliance with applicable laws, including those regarding mapping, of the country where maps, images and other data and third party content that You are authorized to access via the software is made available. 
  c) Third Party Software. The software may include third party applications that Microsoft, not the third party, licenses to you under this agreement. Any included notices for third party applications are for your information only.
  d) Microsoft Online Subscription Agreement. Some features of the software provide access to, or rely on, Microsoft Azure Services. The use of those services (but not the software) is governed by the separate terms and privacy policies associated with your Microsoft Azure subscription. The services may not be available in all regions. For more information see https://go.microsoft.com/fwLink/?LinkID=522330&amp;clcid=0x9.

2. DISTRIBUTABLE CODE. The software is comprised of “Distributable Code”. “Distributable Code” is code that you are permitted to distribute in applications you develop if you comply with the terms below and otherwise set forth in these license terms. 
  a) Distribution Rights. 
    i. You may copy and distribute the object code form of the software.
    i. Third Party Distribution. You may permit distributors of your applications to copy and distribute any of this distributable code you elect to distribute with your applications.
  b) Distribution Requirements. For any code you distribute, you must:
    i. add significant primary functionality to it in your applications;
    ii. require distributors and external end users to agree to terms that protect it and Microsoft at least as much as this agreement; and
    iii. indemnify, defend, and hold harmless Microsoft from any claims, including attorneys’ fees, related to the distribution or use of your applications, except to the extent that any claim is based solely on the unmodified distributable code.
  c) Distribution Restrictions. You may not:
    i. use Microsoft’s trademarks or trade dress in your application in any way that suggests your application comes from or is endorsed by Microsoft; or
    ii. modify or distribute the source code of any distributable code so that any part of it becomes subject to any license that requires that the distributable code, any other part of the software, or any of Microsoft’s other intellectual property be disclosed or distributed in source code form, or that others have the right to modify it.

3. DATA COLLECTION. The software may collect information about you and your use of the software and send that to Microsoft. Microsoft may use this information to provide services and improve Microsoft’s products and services. Your opt-out rights, if any, are described in the product documentation. Some features in the software may enable collection of data from users of your applications that access or use the software. If you use these features to enable data collection in your applications, you must comply with applicable law, including getting any required user consent, and maintain a prominent privacy policy that accurately informs users about how you use, collect, and share their data. You can learn more about Microsoft’s data collection and use in the product documentation and the Microsoft Privacy Statement at https://go.microsoft.com/fwlink/?LinkId=512132. You agree to comply with all applicable provisions of the Microsoft Privacy Statement.

4. SCOPE OF LICENSE. The software is licensed, not sold. Microsoft reserves all other rights. Unless applicable law gives you more rights despite this limitation, you will not (and have no right to):
  a) work around any technical limitations in the software that only allow you to use it in certain ways;
  b) reverse engineer, decompile, or disassemble the software, or attempt to do so, except and only to the extent permitted by licensing terms governing the use of open-source components that may be included with the software;
  c) remove, minimize, block, or modify any notices of Microsoft or its suppliers in the software;
  d) use the software in any way that is against the law or to create or propagate malware; or
  e) share, publish, distribute, or lend the software (except for any distributable code, subject to the terms above), provide the software as a stand-alone hosted solution for others to use, or transfer the software or this agreement to any third party.

5. EXPORT RESTRICTIONS. You must comply with all domestic and international export laws and regulations that apply to the software, which include restrictions on destinations, end users, and end use. For further information on export restrictions, visit http://aka.ms/exporting.

6. SUPPORT SERVICES. Microsoft is not obligated under this agreement to provide any support services for the software. Any support provided is “as is”, “with all faults”, and without warranty of any kind.

7. UPDATES. The software may periodically check for updates, and download and install them for you. You may obtain updates only from Microsoft or authorized sources. Microsoft may need to update your system to provide you with updates. You agree to receive these automatic updates without any additional notice. Updates may not include or support all existing software features, services, or peripheral devices.

8. ENTIRE AGREEMENT. This agreement, and any other terms Microsoft may provide for supplements, updates, or third-party applications, is the entire agreement for the software.

9. APPLICABLE LAW AND PLACE TO RESOLVE DISPUTES. If you acquired the software in the United States or Canada, the laws of the state or province where you live (or, if a business, where your principal place of business is located) govern the interpretation of this agreement, claims for its breach, and all other claims (including consumer protection, unfair competition, and tort claims), regardless of conflict of laws principles. If you acquired the software in any other country, its laws apply. If U.S. federal jurisdiction exists, you and Microsoft consent to exclusive jurisdiction and venue in the federal court in King County, Washington for all disputes heard in court. If not, you and Microsoft consent to exclusive jurisdiction and venue in the Superior Court of King County, Washington for all disputes heard in court.

10. CONSUMER RIGHTS; REGIONAL VARIATIONS. This agreement describes certain legal rights. You may have other rights, including consumer rights, under the laws of your state or country. Separate and apart from your relationship with Microsoft, you may also have rights with respect to the party from which you acquired the software. This agreement does not change those other rights if the laws of your state or country do not permit it to do so. For example, if you acquired the software in one of the below regions, or mandatory country law applies, then the following provisions apply to you:
  a) Australia. You have statutory guarantees under the Australian Consumer Law and nothing in this agreement is intended to affect those rights.
  b) Canada. If you acquired this software in Canada, you may stop receiving updates by turning off the automatic update feature, disconnecting your device from the Internet (if and when you re-connect to the Internet, however, the software will resume checking for and installing updates), or uninstalling the software. The product documentation, if any, may also specify how to turn off updates for your specific device or software.
  c) Germany and Austria.
    i. Warranty. The properly licensed software will perform substantially as described in any Microsoft materials that accompany the software. However, Microsoft gives no contractual guarantee in relation to the licensed software.
    ii. Limitation of Liability. In case of intentional conduct, gross negligence, claims based on the Product Liability Act, as well as, in case of death or personal or physical injury, Microsoft is liable according to the statutory law.
  Subject to the foregoing clause ii., Microsoft will only be liable for slight negligence if Microsoft is in breach of such material contractual obligations, the fulfillment of which facilitate the due performance of this agreement, the breach of which would endanger the purpose of this agreement and the compliance with which a party may constantly trust in (so-called "cardinal obligations"). In other cases of slight negligence, Microsoft will not be liable for slight negligence.

11. DISCLAIMER OF WARRANTY. THE SOFTWARE IS LICENSED “AS IS.” YOU BEAR THE RISK OF USING IT. MICROSOFT GIVES NO EXPRESS WARRANTIES, GUARANTEES, OR CONDITIONS. TO THE EXTENT PERMITTED UNDER APPLICABLE LAWS, MICROSOFT EXCLUDES ALL IMPLIED WARRANTIES, INCLUDING MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.

12. LIMITATION ON AND EXCLUSION OF DAMAGES. IF YOU HAVE ANY BASIS FOR RECOVERING DAMAGES DESPITE THE PRECEDING DISCLAIMER OF WARRANTY, YOU CAN RECOVER FROM MICROSOFT AND ITS SUPPLIERS ONLY DIRECT DAMAGES UP TO U.S. $5.00. YOU CANNOT RECOVER ANY OTHER DAMAGES, INCLUDING CONSEQUENTIAL, LOST PROFITS, SPECIAL, INDIRECT, OR INCIDENTAL DAMAGES.
This limitation applies to (a) anything related to the software, services, content (including code) on third party Internet sites, or third party applications; and (b) claims for breach of contract, warranty, guarantee, or condition; strict liability, negligence, or other tort; or any other claim; in each case to the extent permitted by applicable law.
It also applies even if Microsoft knew or should have known about the possibility of the damages. The above limitation or exclusion may not apply to you because your state, province, or country may not allow the exclusion or limitation of incidental, consequential, or other damages.

Please note: As this software is distributed in Canada, some of the clauses in this agreement are provided below in French.

Remarque: Ce logiciel étant distribué au Canada, certaines des clauses dans ce contrat sont fournies ci-dessous en français.

EXONÉRATION DE GARANTIE. Le logiciel visé par une licence est offert « tel quel ». Toute utilisation de ce logiciel est à votre seule risque et péril. Microsoft n’accorde aucune autre garantie expresse. Vous pouvez bénéficier de droits additionnels en vertu du droit local sur la protection des consommateurs, que ce contrat ne peut modifier. La ou elles sont permises par le droit locale, les garanties implicites de qualité marchande, d’adéquation à un usage particulier et d’absence de contrefaçon sont exclues.

LIMITATION DES DOMMAGES-INTÉRÊTS ET EXCLUSION DE RESPONSABILITÉ POUR LES DOMMAGES. Vous pouvez obtenir de Microsoft et de ses fournisseurs une indemnisation en cas de dommages directs uniquement à hauteur de 5,00 $ US. Vous ne pouvez prétendre à aucune indemnisation pour les autres dommages, y compris les dommages spéciaux, indirects ou accessoires et pertes de bénéfices.

Cette limitation concerne:
• tout ce qui est relié au logiciel, aux services ou au contenu (y compris le code) figurant sur des sites Internet tiers ou dans des programmes tiers; et
• les réclamations au titre de violation de contrat ou de garantie, ou au titre de responsabilité stricte, de négligence ou d’une autre faute dans la limite autorisée par la loi en vigueur.

Elle s’applique également, même si Microsoft connaissait ou devrait connaître l’éventualité d’un tel dommage. Si votre pays n’autorise pas l’exclusion ou la limitation de responsabilité pour les dommages indirects, accessoires ou de quelque nature que ce soit, il se peut que la limitation ou l’exclusion ci-dessus ne s’appliquera pas à votre égard.

EFFET JURIDIQUE. Le présent contrat décrit certains droits juridiques. Vous pourriez avoir d’autres droits prévus par les lois de votre pays. Le présent contrat ne modifie pas les droits que vous confèrent les lois de votre pays si celles-ci ne le permettent pas.
---
title: THIRD PARTY NOTICES FOR Azure Maps Drawing Tools Module
preamble: |
	Do Not Translate or Localize

	This file is based on or incorporates material from the projects listed below (Third Party IP).
	The original copyright notice and the license under which Microsoft received such Third Party IP,
	are set forth below. Such licenses and notices are provided for informational purposes only.
	Microsoft licenses the Third Party IP to you under the licensing terms for the Microsoft product.
	Microsoft reserves all other rights not expressly granted under this agreement, whether by implication,
	estoppel or otherwise.


registrations:
	- component:
		name: @types/lodash
		version: 4.14.171
		license: |
    MIT License

    Copyright (c) Microsoft Corporation.

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE


	- component:
		name: azure-maps-control
		version: 2.1.1
		license: |
MICROSOFT SOFTWARE LICENSE TERMS
MICROSOFT AZURE MAPS WEB SDK
These license terms are an agreement between you and Microsoft Corporation (or one of its affiliates). They apply to the software named above and any Microsoft services or software updates (except to the extent such services or updates are accompanied by new or additional terms, in which case those different terms apply prospectively and do not alter your or Microsoft’s rights relating to pre-updated software or services). IF YOU COMPLY WITH THESE LICENSE TERMS, YOU HAVE THE RIGHTS BELOW.  BY USING THE SOFTWARE, YOU ACCEPT THESE TERMS.
1. INSTALLATION AND USE RIGHTS.
  a) General. You may install and use any number of copies of the software to develop and test your applications.
  b) User Region Parameters. The software will allow you to select from a View list to set the map view within your application for a given customer. By default the View parameter (also referred to as “user region parameter” is set to “Unified”.  Countries/Regions that are not on the View list will default to the “Unified” View. It is your responsibility to determine the location of your users, and then set the View parameter correctly for that location. The View parameter must be used in compliance with applicable laws, including those regarding mapping, of the country where maps, images and other data and third party content that You are authorized to access via the software is made available. 
  c) Third Party Software. The software may include third party applications that Microsoft, not the third party, licenses to you under this agreement. Any included notices for third party applications are for your information only.
  d) Microsoft Online Subscription Agreement. Some features of the software provide access to, or rely on, Microsoft Azure Services. The use of those services (but not the software) is governed by the separate terms and privacy policies associated with your Microsoft Azure subscription. The services may not be available in all regions. For more information see https://go.microsoft.com/fwLink/?LinkID=522330&amp;clcid=0x9.
2. DISTRIBUTABLE CODE. The software is comprised of “Distributable Code”. “Distributable Code” is code that you are permitted to distribute in applications you develop if you comply with the terms below and otherwise set forth in these license terms. 
  a) Distribution Rights. 
    i. You may copy and distribute the object code form of the software.
    i. Third Party Distribution. You may permit distributors of your applications to copy and distribute any of this distributable code you elect to distribute with your applications.
  b) Distribution Requirements. For any code you distribute, you must:
    i. add significant primary functionality to it in your applications;
    ii. require distributors and external end users to agree to terms that protect it and Microsoft at least as much as this agreement; and
    iii. indemnify, defend, and hold harmless Microsoft from any claims, including attorneys’ fees, related to the distribution or use of your applications, except to the extent that any claim is based solely on the unmodified distributable code.
  c) Distribution Restrictions. You may not:
    i. use Microsoft’s trademarks or trade dress in your application in any way that suggests your application comes from or is endorsed by Microsoft; or
    ii. modify or distribute the source code of any distributable code so that any part of it becomes subject to any license that requires that the distributable code, any other part of the software, or any of Microsoft’s other intellectual property be disclosed or distributed in source code form, or that others have the right to modify it.
3. DATA COLLECTION. The software may collect information about you and your use of the software and send that to Microsoft. Microsoft may use this information to provide services and improve Microsoft’s products and services. Your opt-out rights, if any, are described in the product documentation. Some features in the software may enable collection of data from users of your applications that access or use the software. If you use these features to enable data collection in your applications, you must comply with applicable law, including getting any required user consent, and maintain a prominent privacy policy that accurately informs users about how you use, collect, and share their data. You can learn more about Microsoft’s data collection and use in the product documentation and the Microsoft Privacy Statement at https://go.microsoft.com/fwlink/?LinkId=512132. You agree to comply with all applicable provisions of the Microsoft Privacy Statement.
4. SCOPE OF LICENSE. The software is licensed, not sold. Microsoft reserves all other rights. Unless applicable law gives you more rights despite this limitation, you will not (and have no right to):
  a) work around any technical limitations in the software that only allow you to use it in certain ways;
  b) reverse engineer, decompile, or disassemble the software, or attempt to do so, except and only to the extent permitted by licensing terms governing the use of open-source components that may be included with the software;
  c) remove, minimize, block, or modify any notices of Microsoft or its suppliers in the software;
  d) use the software in any way that is against the law or to create or propagate malware; or
  e) share, publish, distribute, or lend the software (except for any distributable code, subject to the terms above), provide the software as a stand-alone hosted solution for others to use, or transfer the software or this agreement to any third party.
5. EXPORT RESTRICTIONS. You must comply with all domestic and international export laws and regulations that apply to the software, which include restrictions on destinations, end users, and end use. For further information on export restrictions, visit http://aka.ms/exporting.
6. SUPPORT SERVICES. Microsoft is not obligated under this agreement to provide any support services for the software. Any support provided is “as is”, “with all faults”, and without warranty of any kind.
7. UPDATES. The software may periodically check for updates, and download and install them for you. You may obtain updates only from Microsoft or authorized sources. Microsoft may need to update your system to provide you with updates. You agree to receive these automatic updates without any additional notice. Updates may not include or support all existing software features, services, or peripheral devices.
8. ENTIRE AGREEMENT. This agreement, and any other terms Microsoft may provide for supplements, updates, or third-party applications, is the entire agreement for the software.
9. APPLICABLE LAW AND PLACE TO RESOLVE DISPUTES. If you acquired the software in the United States or Canada, the laws of the state or province where you live (or, if a business, where your principal place of business is located) govern the interpretation of this agreement, claims for its breach, and all other claims (including consumer protection, unfair competition, and tort claims), regardless of conflict of laws principles. If you acquired the software in any other country, its laws apply. If U.S. federal jurisdiction exists, you and Microsoft consent to exclusive jurisdiction and venue in the federal court in King County, Washington for all disputes heard in court. If not, you and Microsoft consent to exclusive jurisdiction and venue in the Superior Court of King County, Washington for all disputes heard in court.
10. CONSUMER RIGHTS; REGIONAL VARIATIONS. This agreement describes certain legal rights. You may have other rights, including consumer rights, under the laws of your state or country. Separate and apart from your relationship with Microsoft, you may also have rights with respect to the party from which you acquired the software. This agreement does not change those other rights if the laws of your state or country do not permit it to do so. For example, if you acquired the software in one of the below regions, or mandatory country law applies, then the following provisions apply to you:
  a) Australia. You have statutory guarantees under the Australian Consumer Law and nothing in this agreement is intended to affect those rights.
  b) Canada. If you acquired this software in Canada, you may stop receiving updates by turning off the automatic update feature, disconnecting your device from the Internet (if and when you re-connect to the Internet, however, the software will resume checking for and installing updates), or uninstalling the software. The product documentation, if any, may also specify how to turn off updates for your specific device or software.
  c) Germany and Austria.
    i. Warranty. The properly licensed software will perform substantially as described in any Microsoft materials that accompany the software. However, Microsoft gives no contractual guarantee in relation to the licensed software.
    ii. Limitation of Liability. In case of intentional conduct, gross negligence, claims based on the Product Liability Act, as well as, in case of death or personal or physical injury, Microsoft is liable according to the statutory law.
  Subject to the foregoing clause ii., Microsoft will only be liable for slight negligence if Microsoft is in breach of such material contractual obligations, the fulfillment of which facilitate the due performance of this agreement, the breach of which would endanger the purpose of this agreement and the compliance with which a party may constantly trust in (so-called "cardinal obligations"). In other cases of slight negligence, Microsoft will not be liable for slight negligence.
11. DISCLAIMER OF WARRANTY. THE SOFTWARE IS LICENSED “AS IS.” YOU BEAR THE RISK OF USING IT. MICROSOFT GIVES NO EXPRESS WARRANTIES, GUARANTEES, OR CONDITIONS. TO THE EXTENT PERMITTED UNDER APPLICABLE LAWS, MICROSOFT EXCLUDES ALL IMPLIED WARRANTIES, INCLUDING MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.
12. LIMITATION ON AND EXCLUSION OF DAMAGES. IF YOU HAVE ANY BASIS FOR RECOVERING DAMAGES DESPITE THE PRECEDING DISCLAIMER OF WARRANTY, YOU CAN RECOVER FROM MICROSOFT AND ITS SUPPLIERS ONLY DIRECT DAMAGES UP TO U.S. $5.00. YOU CANNOT RECOVER ANY OTHER DAMAGES, INCLUDING CONSEQUENTIAL, LOST PROFITS, SPECIAL, INDIRECT, OR INCIDENTAL DAMAGES.
This limitation applies to (a) anything related to the software, services, content (including code) on third party Internet sites, or third party applications; and (b) claims for breach of contract, warranty, guarantee, or condition; strict liability, negligence, or other tort; or any other claim; in each case to the extent permitted by applicable law.
It also applies even if Microsoft knew or should have known about the possibility of the damages. The above limitation or exclusion may not apply to you because your state, province, or country may not allow the exclusion or limitation of incidental, consequential, or other damages.
Please note: As this software is distributed in Canada, some of the clauses in this agreement are provided below in French.
Remarque: Ce logiciel étant distribué au Canada, certaines des clauses dans ce contrat sont fournies ci-dessous en français.
EXONÉRATION DE GARANTIE. Le logiciel visé par une licence est offert « tel quel ». Toute utilisation de ce logiciel est à votre seule risque et péril. Microsoft n’accorde aucune autre garantie expresse. Vous pouvez bénéficier de droits additionnels en vertu du droit local sur la protection des consommateurs, que ce contrat ne peut modifier. La ou elles sont permises par le droit locale, les garanties implicites de qualité marchande, d’adéquation à un usage particulier et d’absence de contrefaçon sont exclues.
LIMITATION DES DOMMAGES-INTÉRÊTS ET EXCLUSION DE RESPONSABILITÉ POUR LES DOMMAGES. Vous pouvez obtenir de Microsoft et de ses fournisseurs une indemnisation en cas de dommages directs uniquement à hauteur de 5,00 $ US. Vous ne pouvez prétendre à aucune indemnisation pour les autres dommages, y compris les dommages spéciaux, indirects ou accessoires et pertes de bénéfices.
Cette limitation concerne:
• tout ce qui est relié au logiciel, aux services ou au contenu (y compris le code) figurant sur des sites Internet tiers ou dans des programmes tiers; et
• les réclamations au titre de violation de contrat ou de garantie, ou au titre de responsabilité stricte, de négligence ou d’une autre faute dans la limite autorisée par la loi en vigueur.
Elle s’applique également, même si Microsoft connaissait ou devrait connaître l’éventualité d’un tel dommage. Si votre pays n’autorise pas l’exclusion ou la limitation de responsabilité pour les dommages indirects, accessoires ou de quelque nature que ce soit, il se peut que la limitation ou l’exclusion ci-dessus ne s’appliquera pas à votre égard.
EFFET JURIDIQUE. Le présent contrat décrit certains droits juridiques. Vous pourriez avoir d’autres droits prévus par les lois de votre pays. Le présent contrat ne modifie pas les droits que vous confèrent les lois de votre pays si celles-ci ne le permettent pas.


	- component:
		name: @types/adal-angular
		version: 1.0.2
		license: |
    MIT License

    Copyright (c) Microsoft Corporation.

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE


	- component:
		name: lodash
		version: 4.17.21
		license: |
Copyright OpenJS Foundation and other contributors <https://openjsf.org/>

Based on Underscore.js, copyright Jeremy Ashkenas,
DocumentCloud and Investigative Reporters & Editors <http://underscorejs.org/>

This software consists of voluntary contributions made by many
individuals. For exact contribution history, see the revision history
available at https://github.com/lodash/lodash

The following license applies to all parts of this software except as
documented below:

====

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

====

Copyright and related rights for sample code are waived via CC0. Sample
code is defined as all source code displayed within the prose of the
documentation.

CC0: http://creativecommons.org/publicdomain/zero/1.0/

====

Files located in the node_modules and vendor directories are externally
maintained libraries used by this software which have their own
licenses; we recommend you read them, as their terms may differ from the
terms above.


	- component:
		name: typescript
		version: 3.9.10
		license: |
Apache License

Version 2.0, January 2004

http://www.apache.org/licenses/ 

TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION

1. Definitions.

"License" shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document.

"Licensor" shall mean the copyright owner or entity authorized by the copyright owner that is granting the License.

"Legal Entity" shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, "control" means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity.

"You" (or "Your") shall mean an individual or Legal Entity exercising permissions granted by this License.

"Source" form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files.

"Object" form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types.

"Work" shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below).

"Derivative Works" shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof.

"Contribution" shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, "submitted" means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as "Not a Contribution."

"Contributor" shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work.

2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form.

3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed.

4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions:

You must give any other recipients of the Work or Derivative Works a copy of this License; and

You must cause any modified files to carry prominent notices stating that You changed the files; and

You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and

If the Work includes a "NOTICE" text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License.

5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions.

6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file.

7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License.

8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages.

9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability.

END OF TERMS AND CONDITIONS
*/

"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}Object.defineProperty(exports,"__esModule",{value:!0});var azmaps=require("azure-maps-control"),azmaps__default=_interopDefault(azmaps),extendStatics=function(e,t){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var a in t)t.hasOwnProperty(a)&&(e[a]=t[a])})(e,t)};function __extends(e,t){function a(){this.constructor=e}extendStatics(e,t),e.prototype=null===t?Object.create(t):(a.prototype=t.prototype,new a)}var __assign=function(){return(__assign=Object.assign||function(e){for(var t,a=1,s=arguments.length;a<s;a++)for(var o in t=arguments[a])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e}).apply(this,arguments)};function __spreadArrays(){for(var e=0,t=0,a=arguments.length;t<a;t++)e+=arguments[t].length;for(var s=Array(e),o=0,t=0;t<a;t++)for(var r=arguments[t],i=0,n=r.length;i<n;i++,o++)s[o]=r[i];return s}var Namespace=function(){function e(){}return e.merge=function(e,t){for(var a=window||global,s=0,o=e.split(".");s<o.length;s++){var r=o[s];if(!a[r])return t;a=a[r]}return __assign(__assign({},a),t)},e}();function listCacheClear(){this.__data__=[],this.size=0}var _listCacheClear=listCacheClear;function eq(e,t){return e===t||e!=e&&t!=t}var eq_1=eq;function assocIndexOf(e,t){for(var a=e.length;a--;)if(eq_1(e[a][0],t))return a;return-1}var _assocIndexOf=assocIndexOf,arrayProto=Array.prototype,splice=arrayProto.splice;function listCacheDelete(e){var t=this.__data__,e=_assocIndexOf(t,e);return!(e<0)&&(e==t.length-1?t.pop():splice.call(t,e,1),--this.size,!0)}var _listCacheDelete=listCacheDelete;function listCacheGet(e){var t=this.__data__,e=_assocIndexOf(t,e);return e<0?void 0:t[e][1]}var _listCacheGet=listCacheGet;function listCacheHas(e){return-1<_assocIndexOf(this.__data__,e)}var _listCacheHas=listCacheHas;function listCacheSet(e,t){var a=this.__data__,s=_assocIndexOf(a,e);return s<0?(++this.size,a.push([e,t])):a[s][1]=t,this}var _listCacheSet=listCacheSet;function ListCache(e){var t=-1,a=null==e?0:e.length;for(this.clear();++t<a;){var s=e[t];this.set(s[0],s[1])}}ListCache.prototype.clear=_listCacheClear,ListCache.prototype.delete=_listCacheDelete,ListCache.prototype.get=_listCacheGet,ListCache.prototype.has=_listCacheHas,ListCache.prototype.set=_listCacheSet;var _ListCache=ListCache;function stackClear(){this.__data__=new _ListCache,this.size=0}var _stackClear=stackClear;function stackDelete(e){var t=this.__data__,e=t.delete(e);return this.size=t.size,e}var _stackDelete=stackDelete;function stackGet(e){return this.__data__.get(e)}var _stackGet=stackGet;function stackHas(e){return this.__data__.has(e)}var _stackHas=stackHas,commonjsGlobal="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function createCommonjsModule(e,t){return e(t={exports:{}},t.exports),t.exports}var freeGlobal="object"==typeof commonjsGlobal&&commonjsGlobal&&commonjsGlobal.Object===Object&&commonjsGlobal,_freeGlobal=freeGlobal,freeSelf="object"==typeof self&&self&&self.Object===Object&&self,root=_freeGlobal||freeSelf||Function("return this")(),_root=root,Symbol=_root.Symbol,_Symbol=Symbol,objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty,nativeObjectToString=objectProto.toString,symToStringTag=_Symbol?_Symbol.toStringTag:void 0;function getRawTag(e){var t=hasOwnProperty.call(e,symToStringTag),a=e[symToStringTag];try{var s=!(e[symToStringTag]=void 0)}catch(e){}var o=nativeObjectToString.call(e);return s&&(t?e[symToStringTag]=a:delete e[symToStringTag]),o}var _getRawTag=getRawTag,objectProto$1=Object.prototype,nativeObjectToString$1=objectProto$1.toString;function objectToString(e){return nativeObjectToString$1.call(e)}var _objectToString=objectToString,nullTag="[object Null]",undefinedTag="[object Undefined]",symToStringTag$1=_Symbol?_Symbol.toStringTag:void 0;function baseGetTag(e){return null==e?void 0===e?undefinedTag:nullTag:(symToStringTag$1&&symToStringTag$1 in Object(e)?_getRawTag:_objectToString)(e)}var _baseGetTag=baseGetTag;function isObject(e){var t=typeof e;return null!=e&&("object"==t||"function"==t)}var isObject_1=isObject,asyncTag="[object AsyncFunction]",funcTag="[object Function]",genTag="[object GeneratorFunction]",proxyTag="[object Proxy]";function isFunction(e){if(!isObject_1(e))return!1;e=_baseGetTag(e);return e==funcTag||e==genTag||e==asyncTag||e==proxyTag}var isFunction_1=isFunction,coreJsData=_root["__core-js_shared__"],_coreJsData=coreJsData,maskSrcKey=function(){var e=/[^.]+$/.exec(_coreJsData&&_coreJsData.keys&&_coreJsData.keys.IE_PROTO||"");return e?"Symbol(src)_1."+e:""}();function isMasked(e){return!!maskSrcKey&&maskSrcKey in e}var _isMasked=isMasked,funcProto=Function.prototype,funcToString=funcProto.toString;function toSource(e){if(null!=e){try{return funcToString.call(e)}catch(e){}try{return e+""}catch(e){}}return""}var _toSource=toSource,reRegExpChar=/[\\^$.*+?()[\]{}|]/g,reIsHostCtor=/^\[object .+?Constructor\]$/,funcProto$1=Function.prototype,objectProto$2=Object.prototype,funcToString$1=funcProto$1.toString,hasOwnProperty$1=objectProto$2.hasOwnProperty,reIsNative=RegExp("^"+funcToString$1.call(hasOwnProperty$1).replace(reRegExpChar,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");function baseIsNative(e){return!(!isObject_1(e)||_isMasked(e))&&(isFunction_1(e)?reIsNative:reIsHostCtor).test(_toSource(e))}var _baseIsNative=baseIsNative;function getValue(e,t){return null==e?void 0:e[t]}var _getValue=getValue;function getNative(e,t){t=_getValue(e,t);return _baseIsNative(t)?t:void 0}var _getNative=getNative,Map=_getNative(_root,"Map"),_Map=Map,nativeCreate=_getNative(Object,"create"),_nativeCreate=nativeCreate;function hashClear(){this.__data__=_nativeCreate?_nativeCreate(null):{},this.size=0}var _hashClear=hashClear;function hashDelete(e){e=this.has(e)&&delete this.__data__[e];return this.size-=e?1:0,e}var _hashDelete=hashDelete,HASH_UNDEFINED="__lodash_hash_undefined__",objectProto$3=Object.prototype,hasOwnProperty$2=objectProto$3.hasOwnProperty;function hashGet(e){var t=this.__data__;if(_nativeCreate){var a=t[e];return a===HASH_UNDEFINED?void 0:a}return hasOwnProperty$2.call(t,e)?t[e]:void 0}var _hashGet=hashGet,objectProto$4=Object.prototype,hasOwnProperty$3=objectProto$4.hasOwnProperty;function hashHas(e){var t=this.__data__;return _nativeCreate?void 0!==t[e]:hasOwnProperty$3.call(t,e)}var _hashHas=hashHas,HASH_UNDEFINED$1="__lodash_hash_undefined__";function hashSet(e,t){var a=this.__data__;return this.size+=this.has(e)?0:1,a[e]=_nativeCreate&&void 0===t?HASH_UNDEFINED$1:t,this}var _hashSet=hashSet;function Hash(e){var t=-1,a=null==e?0:e.length;for(this.clear();++t<a;){var s=e[t];this.set(s[0],s[1])}}Hash.prototype.clear=_hashClear,Hash.prototype.delete=_hashDelete,Hash.prototype.get=_hashGet,Hash.prototype.has=_hashHas,Hash.prototype.set=_hashSet;var _Hash=Hash;function mapCacheClear(){this.size=0,this.__data__={hash:new _Hash,map:new(_Map||_ListCache),string:new _Hash}}var _mapCacheClear=mapCacheClear;function isKeyable(e){var t=typeof e;return"string"==t||"number"==t||"symbol"==t||"boolean"==t?"__proto__"!==e:null===e}var _isKeyable=isKeyable;function getMapData(e,t){e=e.__data__;return _isKeyable(t)?e["string"==typeof t?"string":"hash"]:e.map}var _getMapData=getMapData;function mapCacheDelete(e){e=_getMapData(this,e).delete(e);return this.size-=e?1:0,e}var _mapCacheDelete=mapCacheDelete;function mapCacheGet(e){return _getMapData(this,e).get(e)}var _mapCacheGet=mapCacheGet;function mapCacheHas(e){return _getMapData(this,e).has(e)}var _mapCacheHas=mapCacheHas;function mapCacheSet(e,t){var a=_getMapData(this,e),s=a.size;return a.set(e,t),this.size+=a.size==s?0:1,this}var _mapCacheSet=mapCacheSet;function MapCache(e){var t=-1,a=null==e?0:e.length;for(this.clear();++t<a;){var s=e[t];this.set(s[0],s[1])}}MapCache.prototype.clear=_mapCacheClear,MapCache.prototype.delete=_mapCacheDelete,MapCache.prototype.get=_mapCacheGet,MapCache.prototype.has=_mapCacheHas,MapCache.prototype.set=_mapCacheSet;var _MapCache=MapCache,LARGE_ARRAY_SIZE=200;function stackSet(e,t){var a=this.__data__;if(a instanceof _ListCache){var s=a.__data__;if(!_Map||s.length<LARGE_ARRAY_SIZE-1)return s.push([e,t]),this.size=++a.size,this;a=this.__data__=new _MapCache(s)}return a.set(e,t),this.size=a.size,this}var _stackSet=stackSet;function Stack(e){e=this.__data__=new _ListCache(e);this.size=e.size}Stack.prototype.clear=_stackClear,Stack.prototype.delete=_stackDelete,Stack.prototype.get=_stackGet,Stack.prototype.has=_stackHas,Stack.prototype.set=_stackSet;var _Stack=Stack;function arrayEach(e,t){for(var a=-1,s=null==e?0:e.length;++a<s&&!1!==t(e[a],a,e););return e}var _arrayEach=arrayEach,defineProperty=function(){try{var e=_getNative(Object,"defineProperty");return e({},"",{}),e}catch(e){}}(),_defineProperty=defineProperty;function baseAssignValue(e,t,a){"__proto__"==t&&_defineProperty?_defineProperty(e,t,{configurable:!0,enumerable:!0,value:a,writable:!0}):e[t]=a}var _baseAssignValue=baseAssignValue,objectProto$5=Object.prototype,hasOwnProperty$4=objectProto$5.hasOwnProperty;function assignValue(e,t,a){var s=e[t];hasOwnProperty$4.call(e,t)&&eq_1(s,a)&&(void 0!==a||t in e)||_baseAssignValue(e,t,a)}var _assignValue=assignValue;function copyObject(e,t,a,s){var o=!a;a=a||{};for(var r=-1,i=t.length;++r<i;){var n=t[r],p=s?s(a[n],e[n],n,a,e):void 0;void 0===p&&(p=e[n]),(o?_baseAssignValue:_assignValue)(a,n,p)}return a}var _copyObject=copyObject;function baseTimes(e,t){for(var a=-1,s=Array(e);++a<e;)s[a]=t(a);return s}var _baseTimes=baseTimes;function isObjectLike(e){return null!=e&&"object"==typeof e}var isObjectLike_1=isObjectLike,argsTag="[object Arguments]";function baseIsArguments(e){return isObjectLike_1(e)&&_baseGetTag(e)==argsTag}var _baseIsArguments=baseIsArguments,objectProto$6=Object.prototype,hasOwnProperty$5=objectProto$6.hasOwnProperty,propertyIsEnumerable=objectProto$6.propertyIsEnumerable,isArguments=_baseIsArguments(function(){return arguments}())?_baseIsArguments:function(e){return isObjectLike_1(e)&&hasOwnProperty$5.call(e,"callee")&&!propertyIsEnumerable.call(e,"callee")},isArguments_1=isArguments,isArray=Array.isArray,isArray_1=isArray;function stubFalse(){return!1}var stubFalse_1=stubFalse,isBuffer_1=createCommonjsModule(function(e,t){var a=t&&!t.nodeType&&t,t=a&&e&&!e.nodeType&&e,a=t&&t.exports===a?_root.Buffer:void 0,a=a?a.isBuffer:void 0;e.exports=a||stubFalse_1}),MAX_SAFE_INTEGER=9007199254740991,reIsUint=/^(?:0|[1-9]\d*)$/;function isIndex(e,t){var a=typeof e;return!!(t=null==t?MAX_SAFE_INTEGER:t)&&("number"==a||"symbol"!=a&&reIsUint.test(e))&&-1<e&&e%1==0&&e<t}var _isIndex=isIndex,MAX_SAFE_INTEGER$1=9007199254740991;function isLength(e){return"number"==typeof e&&-1<e&&e%1==0&&e<=MAX_SAFE_INTEGER$1}var isLength_1=isLength,argsTag$1="[object Arguments]",arrayTag="[object Array]",boolTag="[object Boolean]",dateTag="[object Date]",errorTag="[object Error]",funcTag$1="[object Function]",mapTag="[object Map]",numberTag="[object Number]",objectTag="[object Object]",regexpTag="[object RegExp]",setTag="[object Set]",stringTag="[object String]",weakMapTag="[object WeakMap]",arrayBufferTag="[object ArrayBuffer]",dataViewTag="[object DataView]",float32Tag="[object Float32Array]",float64Tag="[object Float64Array]",int8Tag="[object Int8Array]",int16Tag="[object Int16Array]",int32Tag="[object Int32Array]",uint8Tag="[object Uint8Array]",uint8ClampedTag="[object Uint8ClampedArray]",uint16Tag="[object Uint16Array]",uint32Tag="[object Uint32Array]",typedArrayTags={};function baseIsTypedArray(e){return isObjectLike_1(e)&&isLength_1(e.length)&&!!typedArrayTags[_baseGetTag(e)]}typedArrayTags[float32Tag]=typedArrayTags[float64Tag]=typedArrayTags[int8Tag]=typedArrayTags[int16Tag]=typedArrayTags[int32Tag]=typedArrayTags[uint8Tag]=typedArrayTags[uint8ClampedTag]=typedArrayTags[uint16Tag]=typedArrayTags[uint32Tag]=!0,typedArrayTags[argsTag$1]=typedArrayTags[arrayTag]=typedArrayTags[arrayBufferTag]=typedArrayTags[boolTag]=typedArrayTags[dataViewTag]=typedArrayTags[dateTag]=typedArrayTags[errorTag]=typedArrayTags[funcTag$1]=typedArrayTags[mapTag]=typedArrayTags[numberTag]=typedArrayTags[objectTag]=typedArrayTags[regexpTag]=typedArrayTags[setTag]=typedArrayTags[stringTag]=typedArrayTags[weakMapTag]=!1;var _baseIsTypedArray=baseIsTypedArray;function baseUnary(t){return function(e){return t(e)}}var _baseUnary=baseUnary,_nodeUtil=createCommonjsModule(function(e,t){var t=t&&!t.nodeType&&t,a=t&&e&&!e.nodeType&&e,s=a&&a.exports===t&&_freeGlobal.process,t=function(){try{var e=a&&a.require&&a.require("util").types;return e?e:s&&s.binding&&s.binding("util")}catch(e){}}();e.exports=t}),nodeIsTypedArray=_nodeUtil&&_nodeUtil.isTypedArray,isTypedArray=nodeIsTypedArray?_baseUnary(nodeIsTypedArray):_baseIsTypedArray,isTypedArray_1=isTypedArray,objectProto$7=Object.prototype,hasOwnProperty$6=objectProto$7.hasOwnProperty;function arrayLikeKeys(e,t){var a,s=isArray_1(e),o=!s&&isArguments_1(e),r=!s&&!o&&isBuffer_1(e),i=!s&&!o&&!r&&isTypedArray_1(e),n=s||o||r||i,p=n?_baseTimes(e.length,String):[],l=p.length;for(a in e)!t&&!hasOwnProperty$6.call(e,a)||n&&("length"==a||r&&("offset"==a||"parent"==a)||i&&("buffer"==a||"byteLength"==a||"byteOffset"==a)||_isIndex(a,l))||p.push(a);return p}var _arrayLikeKeys=arrayLikeKeys,objectProto$8=Object.prototype;function isPrototype(e){var t=e&&e.constructor;return e===("function"==typeof t&&t.prototype||objectProto$8)}var _isPrototype=isPrototype;function overArg(t,a){return function(e){return t(a(e))}}var _overArg=overArg,nativeKeys=_overArg(Object.keys,Object),_nativeKeys=nativeKeys,objectProto$9=Object.prototype,hasOwnProperty$7=objectProto$9.hasOwnProperty;function baseKeys(e){if(!_isPrototype(e))return _nativeKeys(e);var t,a=[];for(t in Object(e))hasOwnProperty$7.call(e,t)&&"constructor"!=t&&a.push(t);return a}var _baseKeys=baseKeys;function isArrayLike(e){return null!=e&&isLength_1(e.length)&&!isFunction_1(e)}var isArrayLike_1=isArrayLike;function keys(e){return(isArrayLike_1(e)?_arrayLikeKeys:_baseKeys)(e)}var keys_1=keys;function baseAssign(e,t){return e&&_copyObject(t,keys_1(t),e)}var _baseAssign=baseAssign;function nativeKeysIn(e){var t=[];if(null!=e)for(var a in Object(e))t.push(a);return t}var _nativeKeysIn=nativeKeysIn,objectProto$a=Object.prototype,hasOwnProperty$8=objectProto$a.hasOwnProperty;function baseKeysIn(e){if(!isObject_1(e))return _nativeKeysIn(e);var t,a=_isPrototype(e),s=[];for(t in e)("constructor"!=t||!a&&hasOwnProperty$8.call(e,t))&&s.push(t);return s}var _baseKeysIn=baseKeysIn;function keysIn(e){return isArrayLike_1(e)?_arrayLikeKeys(e,!0):_baseKeysIn(e)}var keysIn_1=keysIn;function baseAssignIn(e,t){return e&&_copyObject(t,keysIn_1(t),e)}var _baseAssignIn=baseAssignIn,_cloneBuffer=createCommonjsModule(function(e,t){var a=t&&!t.nodeType&&t,t=a&&e&&!e.nodeType&&e,a=t&&t.exports===a?_root.Buffer:void 0,s=a?a.allocUnsafe:void 0;e.exports=function(e,t){return t?e.slice():(t=e.length,t=s?s(t):new e.constructor(t),e.copy(t),t)}});function copyArray(e,t){var a=-1,s=e.length;for(t=t||Array(s);++a<s;)t[a]=e[a];return t}var _copyArray=copyArray;function arrayFilter(e,t){for(var a=-1,s=null==e?0:e.length,o=0,r=[];++a<s;){var i=e[a];t(i,a,e)&&(r[o++]=i)}return r}var _arrayFilter=arrayFilter;function stubArray(){return[]}var stubArray_1=stubArray,objectProto$b=Object.prototype,propertyIsEnumerable$1=objectProto$b.propertyIsEnumerable,nativeGetSymbols=Object.getOwnPropertySymbols,getSymbols=nativeGetSymbols?function(t){return null==t?[]:(t=Object(t),_arrayFilter(nativeGetSymbols(t),function(e){return propertyIsEnumerable$1.call(t,e)}))}:stubArray_1,_getSymbols=getSymbols;function copySymbols(e,t){return _copyObject(e,_getSymbols(e),t)}var _copySymbols=copySymbols;function arrayPush(e,t){for(var a=-1,s=t.length,o=e.length;++a<s;)e[o+a]=t[a];return e}var _arrayPush=arrayPush,getPrototype=_overArg(Object.getPrototypeOf,Object),_getPrototype=getPrototype,nativeGetSymbols$1=Object.getOwnPropertySymbols,getSymbolsIn=nativeGetSymbols$1?function(e){for(var t=[];e;)_arrayPush(t,_getSymbols(e)),e=_getPrototype(e);return t}:stubArray_1,_getSymbolsIn=getSymbolsIn;function copySymbolsIn(e,t){return _copyObject(e,_getSymbolsIn(e),t)}var _copySymbolsIn=copySymbolsIn;function baseGetAllKeys(e,t,a){t=t(e);return isArray_1(e)?t:_arrayPush(t,a(e))}var _baseGetAllKeys=baseGetAllKeys;function getAllKeys(e){return _baseGetAllKeys(e,keys_1,_getSymbols)}var _getAllKeys=getAllKeys;function getAllKeysIn(e){return _baseGetAllKeys(e,keysIn_1,_getSymbolsIn)}var _getAllKeysIn=getAllKeysIn,DataView=_getNative(_root,"DataView"),_DataView=DataView,Promise=_getNative(_root,"Promise"),_Promise=Promise,Set=_getNative(_root,"Set"),_Set=Set,WeakMap=_getNative(_root,"WeakMap"),_WeakMap=WeakMap,mapTag$1="[object Map]",objectTag$1="[object Object]",promiseTag="[object Promise]",setTag$1="[object Set]",weakMapTag$1="[object WeakMap]",dataViewTag$1="[object DataView]",dataViewCtorString=_toSource(_DataView),mapCtorString=_toSource(_Map),promiseCtorString=_toSource(_Promise),setCtorString=_toSource(_Set),weakMapCtorString=_toSource(_WeakMap),getTag=_baseGetTag,_getTag=getTag=_DataView&&getTag(new _DataView(new ArrayBuffer(1)))!=dataViewTag$1||_Map&&getTag(new _Map)!=mapTag$1||_Promise&&getTag(_Promise.resolve())!=promiseTag||_Set&&getTag(new _Set)!=setTag$1||_WeakMap&&getTag(new _WeakMap)!=weakMapTag$1?function(e){var t=_baseGetTag(e),e=t==objectTag$1?e.constructor:void 0,e=e?_toSource(e):"";if(e)switch(e){case dataViewCtorString:return dataViewTag$1;case mapCtorString:return mapTag$1;case promiseCtorString:return promiseTag;case setCtorString:return setTag$1;case weakMapCtorString:return weakMapTag$1}return t}:getTag,objectProto$c=Object.prototype,hasOwnProperty$9=objectProto$c.hasOwnProperty;function initCloneArray(e){var t=e.length,a=new e.constructor(t);return t&&"string"==typeof e[0]&&hasOwnProperty$9.call(e,"index")&&(a.index=e.index,a.input=e.input),a}var _initCloneArray=initCloneArray,Uint8Array=_root.Uint8Array,_Uint8Array=Uint8Array;function cloneArrayBuffer(e){var t=new e.constructor(e.byteLength);return new _Uint8Array(t).set(new _Uint8Array(e)),t}var _cloneArrayBuffer=cloneArrayBuffer;function cloneDataView(e,t){t=t?_cloneArrayBuffer(e.buffer):e.buffer;return new e.constructor(t,e.byteOffset,e.byteLength)}var _cloneDataView=cloneDataView,reFlags=/\w*$/;function cloneRegExp(e){var t=new e.constructor(e.source,reFlags.exec(e));return t.lastIndex=e.lastIndex,t}var _cloneRegExp=cloneRegExp,symbolProto=_Symbol?_Symbol.prototype:void 0,symbolValueOf=symbolProto?symbolProto.valueOf:void 0;function cloneSymbol(e){return symbolValueOf?Object(symbolValueOf.call(e)):{}}var _cloneSymbol=cloneSymbol;function cloneTypedArray(e,t){t=t?_cloneArrayBuffer(e.buffer):e.buffer;return new e.constructor(t,e.byteOffset,e.length)}var _cloneTypedArray=cloneTypedArray,boolTag$1="[object Boolean]",dateTag$1="[object Date]",mapTag$2="[object Map]",numberTag$1="[object Number]",regexpTag$1="[object RegExp]",setTag$2="[object Set]",stringTag$1="[object String]",symbolTag="[object Symbol]",arrayBufferTag$1="[object ArrayBuffer]",dataViewTag$2="[object DataView]",float32Tag$1="[object Float32Array]",float64Tag$1="[object Float64Array]",int8Tag$1="[object Int8Array]",int16Tag$1="[object Int16Array]",int32Tag$1="[object Int32Array]",uint8Tag$1="[object Uint8Array]",uint8ClampedTag$1="[object Uint8ClampedArray]",uint16Tag$1="[object Uint16Array]",uint32Tag$1="[object Uint32Array]";function initCloneByTag(e,t,a){var s=e.constructor;switch(t){case arrayBufferTag$1:return _cloneArrayBuffer(e);case boolTag$1:case dateTag$1:return new s(+e);case dataViewTag$2:return _cloneDataView(e,a);case float32Tag$1:case float64Tag$1:case int8Tag$1:case int16Tag$1:case int32Tag$1:case uint8Tag$1:case uint8ClampedTag$1:case uint16Tag$1:case uint32Tag$1:return _cloneTypedArray(e,a);case mapTag$2:return new s;case numberTag$1:case stringTag$1:return new s(e);case regexpTag$1:return _cloneRegExp(e);case setTag$2:return new s;case symbolTag:return _cloneSymbol(e)}}var _initCloneByTag=initCloneByTag,objectCreate=Object.create,baseCreate=function(){function t(){}return function(e){if(!isObject_1(e))return{};if(objectCreate)return objectCreate(e);t.prototype=e;e=new t;return t.prototype=void 0,e}}(),_baseCreate=baseCreate;function initCloneObject(e){return"function"!=typeof e.constructor||_isPrototype(e)?{}:_baseCreate(_getPrototype(e))}var _initCloneObject=initCloneObject,mapTag$3="[object Map]";function baseIsMap(e){return isObjectLike_1(e)&&_getTag(e)==mapTag$3}var _baseIsMap=baseIsMap,nodeIsMap=_nodeUtil&&_nodeUtil.isMap,isMap=nodeIsMap?_baseUnary(nodeIsMap):_baseIsMap,isMap_1=isMap,setTag$3="[object Set]";function baseIsSet(e){return isObjectLike_1(e)&&_getTag(e)==setTag$3}var _baseIsSet=baseIsSet,nodeIsSet=_nodeUtil&&_nodeUtil.isSet,isSet=nodeIsSet?_baseUnary(nodeIsSet):_baseIsSet,isSet_1=isSet,CLONE_DEEP_FLAG=1,CLONE_FLAT_FLAG=2,CLONE_SYMBOLS_FLAG=4,argsTag$2="[object Arguments]",arrayTag$1="[object Array]",boolTag$2="[object Boolean]",dateTag$2="[object Date]",errorTag$1="[object Error]",funcTag$2="[object Function]",genTag$1="[object GeneratorFunction]",mapTag$4="[object Map]",numberTag$2="[object Number]",objectTag$2="[object Object]",regexpTag$2="[object RegExp]",setTag$4="[object Set]",stringTag$2="[object String]",symbolTag$1="[object Symbol]",weakMapTag$2="[object WeakMap]",arrayBufferTag$2="[object ArrayBuffer]",dataViewTag$3="[object DataView]",float32Tag$2="[object Float32Array]",float64Tag$2="[object Float64Array]",int8Tag$2="[object Int8Array]",int16Tag$2="[object Int16Array]",int32Tag$2="[object Int32Array]",uint8Tag$2="[object Uint8Array]",uint8ClampedTag$2="[object Uint8ClampedArray]",uint16Tag$2="[object Uint16Array]",uint32Tag$2="[object Uint32Array]",cloneableTags={};function baseClone(a,s,o,e,t,r){var i,n=s&CLONE_DEEP_FLAG,p=s&CLONE_FLAT_FLAG,l=s&CLONE_SYMBOLS_FLAG;if(void 0!==(i=o?t?o(a,e,t,r):o(a):i))return i;if(!isObject_1(a))return a;var d=isArray_1(a);if(d){if(i=_initCloneArray(a),!n)return _copyArray(a,i)}else{var c=_getTag(a),e=c==funcTag$2||c==genTag$1;if(isBuffer_1(a))return _cloneBuffer(a,n);if(c==objectTag$2||c==argsTag$2||e&&!t){if(i=p||e?{}:_initCloneObject(a),!n)return p?_copySymbolsIn(a,_baseAssignIn(i,a)):_copySymbols(a,_baseAssign(i,a))}else{if(!cloneableTags[c])return t?a:{};i=_initCloneByTag(a,c,n)}}n=(r=r||new _Stack).get(a);if(n)return n;r.set(a,i),isSet_1(a)?a.forEach(function(e){i.add(baseClone(e,s,o,e,a,r))}):isMap_1(a)&&a.forEach(function(e,t){i.set(t,baseClone(e,s,o,t,a,r))});var h=d?void 0:(l?p?_getAllKeysIn:_getAllKeys:p?keysIn_1:keys_1)(a);return _arrayEach(h||a,function(e,t){h&&(e=a[t=e]),_assignValue(i,t,baseClone(e,s,o,t,a,r))}),i}cloneableTags[argsTag$2]=cloneableTags[arrayTag$1]=cloneableTags[arrayBufferTag$2]=cloneableTags[dataViewTag$3]=cloneableTags[boolTag$2]=cloneableTags[dateTag$2]=cloneableTags[float32Tag$2]=cloneableTags[float64Tag$2]=cloneableTags[int8Tag$2]=cloneableTags[int16Tag$2]=cloneableTags[int32Tag$2]=cloneableTags[mapTag$4]=cloneableTags[numberTag$2]=cloneableTags[objectTag$2]=cloneableTags[regexpTag$2]=cloneableTags[setTag$4]=cloneableTags[stringTag$2]=cloneableTags[symbolTag$1]=cloneableTags[uint8Tag$2]=cloneableTags[uint8ClampedTag$2]=cloneableTags[uint16Tag$2]=cloneableTags[uint32Tag$2]=!0,cloneableTags[errorTag$1]=cloneableTags[funcTag$2]=cloneableTags[weakMapTag$2]=!1;var _baseClone=baseClone,CLONE_DEEP_FLAG$1=1,CLONE_SYMBOLS_FLAG$1=4;function cloneDeep(e){return _baseClone(e,CLONE_DEEP_FLAG$1|CLONE_SYMBOLS_FLAG$1)}var cloneDeep_1=cloneDeep,HASH_UNDEFINED$2="__lodash_hash_undefined__";function setCacheAdd(e){return this.__data__.set(e,HASH_UNDEFINED$2),this}var _setCacheAdd=setCacheAdd;function setCacheHas(e){return this.__data__.has(e)}var _setCacheHas=setCacheHas;function SetCache(e){var t=-1,a=null==e?0:e.length;for(this.__data__=new _MapCache;++t<a;)this.add(e[t])}SetCache.prototype.add=SetCache.prototype.push=_setCacheAdd,SetCache.prototype.has=_setCacheHas;var _SetCache=SetCache;function arraySome(e,t){for(var a=-1,s=null==e?0:e.length;++a<s;)if(t(e[a],a,e))return!0;return!1}var _arraySome=arraySome;function cacheHas(e,t){return e.has(t)}var _cacheHas=cacheHas,COMPARE_PARTIAL_FLAG=1,COMPARE_UNORDERED_FLAG=2;function equalArrays(e,t,a,s,o,r){var i=a&COMPARE_PARTIAL_FLAG,n=e.length,p=t.length;if(n!=p&&!(i&&n<p))return!1;var l=r.get(e),p=r.get(t);if(l&&p)return l==t&&p==e;var d=-1,c=!0,h=a&COMPARE_UNORDERED_FLAG?new _SetCache:void 0;for(r.set(e,t),r.set(t,e);++d<n;){var u,g=e[d],y=t[d];if(void 0!==(u=s?i?s(y,g,d,t,e,r):s(g,y,d,e,t,r):u)){if(u)continue;c=!1;break}if(h){if(!_arraySome(t,function(e,t){if(!_cacheHas(h,t)&&(g===e||o(g,e,a,s,r)))return h.push(t)})){c=!1;break}}else if(g!==y&&!o(g,y,a,s,r)){c=!1;break}}return r.delete(e),r.delete(t),c}var _equalArrays=equalArrays;function mapToArray(e){var a=-1,s=Array(e.size);return e.forEach(function(e,t){s[++a]=[t,e]}),s}var _mapToArray=mapToArray;function setToArray(e){var t=-1,a=Array(e.size);return e.forEach(function(e){a[++t]=e}),a}var _setToArray=setToArray,COMPARE_PARTIAL_FLAG$1=1,COMPARE_UNORDERED_FLAG$1=2,boolTag$3="[object Boolean]",dateTag$3="[object Date]",errorTag$2="[object Error]",mapTag$5="[object Map]",numberTag$3="[object Number]",regexpTag$3="[object RegExp]",setTag$5="[object Set]",stringTag$3="[object String]",symbolTag$2="[object Symbol]",arrayBufferTag$3="[object ArrayBuffer]",dataViewTag$4="[object DataView]",symbolProto$1=_Symbol?_Symbol.prototype:void 0,symbolValueOf$1=symbolProto$1?symbolProto$1.valueOf:void 0;function equalByTag(e,t,a,s,o,r,i){switch(a){case dataViewTag$4:if(e.byteLength!=t.byteLength||e.byteOffset!=t.byteOffset)return!1;e=e.buffer,t=t.buffer;case arrayBufferTag$3:return e.byteLength==t.byteLength&&r(new _Uint8Array(e),new _Uint8Array(t))?!0:!1;case boolTag$3:case dateTag$3:case numberTag$3:return eq_1(+e,+t);case errorTag$2:return e.name==t.name&&e.message==t.message;case regexpTag$3:case stringTag$3:return e==t+"";case mapTag$5:var n=_mapToArray;case setTag$5:n=n||_setToArray;if(e.size!=t.size&&!(s&COMPARE_PARTIAL_FLAG$1))return!1;var p=i.get(e);if(p)return p==t;s|=COMPARE_UNORDERED_FLAG$1,i.set(e,t);n=_equalArrays(n(e),n(t),s,o,r,i);return i.delete(e),n;case symbolTag$2:if(symbolValueOf$1)return symbolValueOf$1.call(e)==symbolValueOf$1.call(t)}return!1}var _equalByTag=equalByTag,COMPARE_PARTIAL_FLAG$2=1,objectProto$d=Object.prototype,hasOwnProperty$a=objectProto$d.hasOwnProperty;function equalObjects(e,t,a,s,o,r){var i=a&COMPARE_PARTIAL_FLAG$2,n=_getAllKeys(e),p=n.length;if(p!=_getAllKeys(t).length&&!i)return!1;for(var l=p;l--;){var d=n[l];if(!(i?d in t:hasOwnProperty$a.call(t,d)))return!1}var c=r.get(e),h=r.get(t);if(c&&h)return c==t&&h==e;var u=!0;r.set(e,t),r.set(t,e);for(var g=i;++l<p;){var y,m=e[d=n[l]],v=t[d];if(!(void 0===(y=s?i?s(v,m,d,t,e,r):s(m,v,d,e,t,r):y)?m===v||o(m,v,a,s,r):y)){u=!1;break}g=g||"constructor"==d}return!u||g||(c=e.constructor)!=(h=t.constructor)&&"constructor"in e&&"constructor"in t&&!("function"==typeof c&&c instanceof c&&"function"==typeof h&&h instanceof h)&&(u=!1),r.delete(e),r.delete(t),u}var _equalObjects=equalObjects,COMPARE_PARTIAL_FLAG$3=1,argsTag$3="[object Arguments]",arrayTag$2="[object Array]",objectTag$3="[object Object]",objectProto$e=Object.prototype,hasOwnProperty$b=objectProto$e.hasOwnProperty;function baseIsEqualDeep(e,t,a,s,o,r){var i=isArray_1(e),n=isArray_1(t),p=i?arrayTag$2:_getTag(e),l=n?arrayTag$2:_getTag(t),d=(p=p==argsTag$3?objectTag$3:p)==objectTag$3,n=(l=l==argsTag$3?objectTag$3:l)==objectTag$3,l=p==l;if(l&&isBuffer_1(e)){if(!isBuffer_1(t))return!1;d=!(i=!0)}if(l&&!d)return r=r||new _Stack,i||isTypedArray_1(e)?_equalArrays(e,t,a,s,o,r):_equalByTag(e,t,p,a,s,o,r);if(!(a&COMPARE_PARTIAL_FLAG$3)){d=d&&hasOwnProperty$b.call(e,"__wrapped__"),n=n&&hasOwnProperty$b.call(t,"__wrapped__");if(d||n)return o(d?e.value():e,n?t.value():t,a,s,r=r||new _Stack)}return!!l&&(r=r||new _Stack,_equalObjects(e,t,a,s,o,r))}var _baseIsEqualDeep=baseIsEqualDeep;function baseIsEqual(e,t,a,s,o){return e===t||(null==e||null==t||!isObjectLike_1(e)&&!isObjectLike_1(t)?e!=e&&t!=t:_baseIsEqualDeep(e,t,a,s,baseIsEqual,o))}var _baseIsEqual=baseIsEqual;function isEqual(e,t){return _baseIsEqual(e,t)}var DrawingMode,isEqual_1=isEqual;!function(e){e.drawPoint="draw-point",e.drawLine="draw-line",e.drawPolygon="draw-polygon",e.drawCircle="draw-circle",e.drawRectangle="draw-rectangle",e.editGeometry="edit-geometry",e.eraseGeometry="erase-geometry",e.idle="idle"}(DrawingMode=DrawingMode||{});var Options=function(){function n(){}return n.prototype.merge=function(){for(var e,t=[],a=0;a<arguments.length;a++)t[a]=arguments[a];for(var s=0,o=t;s<o.length;s++){var r=o[s];if(r)for(var i in r)r.hasOwnProperty(i)&&this.hasOwnProperty(i)&&(void 0!==r[i]&&null!=r[i]?this[i]instanceof n?this[i].merge(r[i]):this[i]="dragHandleStyle"===i||"secondaryDragHandleStyle"===i?__assign(__assign({},this[i]),r[i]):r[i]:(e=e||new(Object.getPrototypeOf(this).constructor),this[i]=e[i]))}return this},n}(),DrawingToolbarOptions=function(t){function e(){var e=null!==t&&t.apply(this,arguments)||this;return e.containerId=void 0,e.position=azmaps.ControlPosition.NonFixed,e.buttons=[DrawingMode.drawPoint,DrawingMode.drawLine,DrawingMode.drawPolygon,DrawingMode.drawCircle,DrawingMode.drawRectangle,DrawingMode.editGeometry,DrawingMode.eraseGeometry],e.numColumns=1/0,e.style="light",e.visible=!0,e}return __extends(e,t),e}(Options),DrawingToolbar=function(){function i(e){var s=this;this._updateStyle=function(){s._setStyle(s.options)},this._updateMode=function(e){for(var t=0;t<s.toolbar.children.length;t++){var a=s.toolbar.children.item(t);a.dataset.mode===e?a.classList.add(i.Css.active):a.classList.remove(i.Css.active)}},this.options=(new DrawingToolbarOptions).merge(cloneDeep_1(e))}return i.prototype.getOptions=function(){return cloneDeep_1(this.options)},i.prototype.setOptions=function(e){var t=(new DrawingToolbarOptions).merge(this.options,cloneDeep_1(e));if(this.toolbar){if(t.visible!==this.options.visible&&(t.visible?this.toolbar.classList.remove(i.Css.hide):this.toolbar.classList.add(i.Css.hide)),t.containerId!==this.options.containerId)if(t.containerId){e=document.getElementById(t.containerId);if(!e)throw new Error("There is no container with ID '"+this.options.containerId+" to add the toolbar to.");this.map.controls.remove(this),e.appendChild(this.toolbar)}else this.toolbar.remove(),t.position!==azmaps.ControlPosition.NonFixed&&this._constructControl(),this.map.controls.add(this,{position:t.position});else t.containerId||t.position===this.options.position||(this.map.controls.remove(this),t.position!==azmaps.ControlPosition.NonFixed&&this._constructControl(),this.map.controls.add(this,{position:t.position}));if(t.style!==this.options.style&&(this._setStyle(t),"auto"===t.style?this.map.events.add("styledata",this._updateStyle):this.map.events.remove("styledata",this._updateStyle)),isEqual_1(t.buttons,this.options.buttons)){if(t.numColumns!==this.options.numColumns)for(var a=this.toolbar.children,s=0;s<a.length;s++){var o=a.item(s);(s+1)%t.numColumns!=0?o.style.cssFloat="left":o.style.cssFloat=null}}else{for(;this.toolbar.firstChild;)this.toolbar.removeChild(this.toolbar.firstChild);this._addButtons(this.drawMgr,t)}}this.options=t},i.prototype.onAdd=function(){if(!this.toolbar)throw new Error("The toolbar cannot be added directly to the map, it must be passed to a DrawingManager");return this.control||this.toolbar},i.prototype.onRemove=function(){(this.control||this.toolbar).remove(),delete this.control},i.prototype._open=function(e,t){if(this.toolbar)throw new Error("The toolbar is already opened, it cannot be opened again.");if(this.map=t,this.drawMgr=e,this.options.containerId){var a=document.getElementById(this.options.containerId);if(!a)throw new Error("There is no container with ID '"+this.options.containerId+" to add the toolbar to.");this._constructToolbar(e,t),a.appendChild(this.toolbar)}else this._constructToolbar(e,t),this.options.position!==azmaps.ControlPosition.NonFixed&&this._constructControl(),t.controls.add(this,{position:this.options.position})},i.prototype._close=function(){if(!this.toolbar)throw new Error("Cannot close the toolbar, it has not been opened yet.");this.options.containerId?this.toolbar.remove():this.map.controls.remove(this),this.map.events.remove("drawingmodechanged",this.drawMgr,this._updateMode),this.map.events.remove("styledata",this._updateStyle),delete this.toolbar,delete this.drawMgr,delete this.map},i.prototype._isOpen=function(){return!!this.toolbar},i.prototype._dispose=function(){this._close()},i.prototype._constructToolbar=function(e,t){this.toolbar=document.createElement("div"),this.toolbar.classList.add(i.Css.toolbar),this._setStyle(this.options),"auto"===this.options.style&&t.events.add("styledata",this._updateStyle),this.options.visible||this.toolbar.classList.add(i.Css.hide),t.events.add("drawingmodechanged",e,this._updateMode),this._addButtons(e,this.options)},i.prototype._addButtons=function(e,t){for(var a=e.getOptions().mode,s=0;s<t.buttons.length;s++){var o=t.buttons[s],r=document.createElement("button");r.type="button",r.dataset.mode=o,r.setAttribute("aria-label",o),r.setAttribute("title",o),r.classList.add(i.Css.button,o),r.addEventListener("click",this._getBtnCallback(r,e)),(s+1)%t.numColumns!=0&&(r.style.cssFloat="left"),a===o&&r.classList.add(i.Css.active),this.toolbar.appendChild(r)}},i.prototype._getBtnCallback=function(t,a){switch(t.dataset.mode){case DrawingMode.drawPoint:case DrawingMode.drawLine:case DrawingMode.drawPolygon:case DrawingMode.drawCircle:case DrawingMode.drawRectangle:case DrawingMode.editGeometry:case DrawingMode.eraseGeometry:return function(){var e=a.getOptions().mode;t.dataset.mode===e?a.setOptions({mode:DrawingMode.idle}):a.setOptions({mode:t.dataset.mode})};default:throw new Error("Invalid button type specified '"+t.dataset.mode+"'.")}},i.prototype._constructControl=function(){this.control=document.createElement("div"),this.control.classList.add(i.Css.control),this.control.appendChild(this.toolbar)},i.prototype._setStyle=function(e){for(var t=0,a=Object.keys(i.Css.styles);t<a.length;t++){var s=a[t];this.toolbar.classList.remove(i.Css.styles[s])}if("auto"===e.style)this.toolbar.classList.add(i.Css.styles.light);else{if(!i.Css.styles.hasOwnProperty(e.style))throw new Error("An invalid style '"+e.style+"' was specified for the toolbar.");this.toolbar.classList.add(i.Css.styles[e.style])}},i.Css={active:"active",button:"azure-maps-drawtoolbar-button",container:"azure-maps-drawtoolbar-container",control:"azure-maps-control-container",hide:"hidden-accessible-element",styles:{dark:"dark",light:"light"},toolbar:"azure-maps-drawtoolbar"},i}(),baseControl=Object.freeze({__proto__:null,DrawingToolbar:DrawingToolbar}),CLONE_DEEP_FLAG$2=1,CLONE_SYMBOLS_FLAG$2=4;function cloneDeepWith(e,t){return _baseClone(e,CLONE_DEEP_FLAG$2|CLONE_SYMBOLS_FLAG$2,t="function"==typeof t?t:void 0)}var DrawingInteractionType,cloneDeepWith_1=cloneDeepWith,DrawingLayers=function(){},PropertyEditorDialogOptions=function(t){function e(){var e=null!==t&&t.apply(this,arguments)||this;return e.container=void 0,e.backgroundColor="rgba(0, 0, 0, 0.3)",e.style="light",e}return __extends(e,t),e}(Options),PropertyEditorDialog=function(){function c(e){this.options=(new PropertyEditorDialogOptions).merge(Object.assign({},e)),this._constructDialog(this.options)}return c.prototype.close=function(){},c.prototype.edit=function(e){if(this.shape!==e){this._clearProps(),this.shape=e,this.tempProps=e.getProperties();for(var t=0,a=Object.keys(this.tempProps);t<a.length;t++){var s=a[t];s.startsWith("_azureMaps")||this._addProp(s,this.tempProps[s])}}if(!this.container.parentElement)if("string"==typeof this.options.container){e=document.getElementById(this.options.container);if(!e)throw new Error("There is no element with ID '"+this.options.container+" to add the editor to.");e.appendChild(this.container)}else this.options.container,azmaps.Map},c.prototype.getOptions=function(){return Object.assign({},this.options)},c.prototype.save=function(){this.close()},c.prototype.setOptions=function(e){e=(new PropertyEditorDialogOptions).merge(this.options,Object.assign({},e));this.options=e},c.prototype._constructDialog=function(e){var t=this;this.container=document.createElement("div"),this.container.classList.add(c.Css.container),this.container.style.backgroundColor=e.backgroundColor,this.dialog=document.createElement("div"),this.dialog.classList.add(c.Css.dialog),this._updateStyle(e),this.container.appendChild(this.dialog);var a=document.createElement("label");a.classList.add(c.Css.labels.base,c.Css.labels.property),a.innerHTML="Property",this.dialog.appendChild(a);e=document.createElement("label");e.classList.add(c.Css.labels.base,c.Css.labels.type),e.innerHTML="Type",this.dialog.appendChild(e);a=document.createElement("label");a.classList.add(c.Css.labels.base,c.Css.labels.value),a.innerHTML="Value",this.dialog.appendChild(a);e=document.createElement("hr");e.classList.add(c.Css.labels.base,c.Css.labels.bar),this.dialog.appendChild(e),this.propsList=document.createElement("ul"),this.propsList.classList.add(c.Css.table.base,c.Css.table.list),this.dialog.appendChild(this.propsList);a=document.createElement("button");a.classList.add(c.Css.buttons.base,c.Css.buttons.add),a.addEventListener("click",function(){return t._addProp()}),this.dialog.appendChild(a);e=document.createElement("div");a.appendChild(e),this.addPropLbl=document.createElement("label"),a.appendChild(this.addPropLbl),this.cancelBtn=document.createElement("button"),this.cancelBtn.classList.add(c.Css.buttons.base,c.Css.buttons.cancel),this.cancelBtn.addEventListener("click",function(){return t.close()}),this.dialog.appendChild(this.cancelBtn),this.saveBtn=document.createElement("button"),this.saveBtn.classList.add(c.Css.buttons.base,c.Css.buttons.save),this.saveBtn.addEventListener("click",function(){return t.save()}),this.dialog.appendChild(this.saveBtn),this._setLocalizedText()},c.prototype._addProp=function(e,t){var a=this,s=document.createElement("div");s.classList.add(c.Css.table.base,c.Css.table.row),this.propsList.appendChild(s);var o=document.createElement("input");o.classList.add(c.Css.table.base,c.Css.table.name),o.type="text",o.value=e||"",s.appendChild(o);var r=document.createElement("select");r.classList.add(c.Css.table.base,c.Css.table.type),s.appendChild(r);for(var i=0,n=c.Types;i<n.length;i++){var p=n[i],l=document.createElement("option");l.value=p,l.innerText=p,r.add(l),(t&&typeof t===p||!t&&"string"===p)&&(l.selected=!0)}var d=document.createElement("div");d.classList.add(c.Css.table.base,c.Css.table.value),d.addEventListener("keydown",function(e){return a._constrainSize(r,d,e)}),d.innerText=t?JSON.stringify(t,null,2):"",d.contentEditable="true",s.appendChild(d);o=document.createElement("button");o.classList.add(c.Css.table.base,c.Css.table.delete),o.addEventListener("click",function(){return a.propsList.removeChild(s)}),s.appendChild(o)},c.prototype._clearProps=function(){for(delete this.tempProps;this.propsList.firstChild;)this.propsList.removeChild(this.propsList.firstChild)},c.prototype._constrainSize=function(e,t,a){"object"!==e.value&&13===a.keyCode&&a.preventDefault()},c.prototype._updateStyle=function(e){for(var t=0,a=Object.keys(c.Css.styles);t<a.length;t++){var s=a[t];this.dialog.classList.remove(c.Css.styles[s])}if("auto"===e.style)this.dialog.classList.add(c.Css.styles.light);else{if(!c.Css.styles.hasOwnProperty(e.style))throw new Error("An invalid style '"+e.style+"' was specified for the editor.");this.dialog.classList.add(c.Css.styles[e.style])}},c.prototype._setLocalizedText=function(){this.saveBtn.innerText="Save",this.cancelBtn.innerText="Cancel",this.addPropLbl.innerText="Add property"},c._countLines=function(e){e=e.match(this.LineCountRegEx);return e?e.length+1:1},c.Css={buttons:{add:"add",base:"azure-maps-propedit-button",cancel:"cancel",save:"save"},container:"azure-maps-propedit-container",dialog:"azure-maps-propedit-dialog",hide:"hidden-accessible-element",labels:{bar:"bar",base:"azure-maps-propedit-label",property:"prop",type:"type",value:"value"},styles:{dark:"dark",light:"light"},table:{base:"azure-maps-propedit-table",delete:"delete",list:"list",name:"name",row:"row",type:"type",value:"value"}},c.Types=["boolean","number","object","string"],c.LineCountRegEx=new RegExp("\r*\n","g"),c.Render=document.createElement("canvas").getContext("2d"),c}();!function(e){e.hybrid="hybrid",e.freehand="freehand",e.click="click"}(DrawingInteractionType=DrawingInteractionType||{});var HandleType,DrawingManagerOptions=function(t){function e(){var e=null!==t&&t.apply(this,arguments)||this;return e.dragHandleStyle={anchor:"center",draggable:!0,htmlContent:"<svg width='12' height='12' viewBox='0 0 12 12' fill='none' xmlns='http://www.w3.org/2000/svg'> <circle class='dragHandleCircle' cx = '6' cy = '6' r = '5.5' fill='#FFFFFF' stroke='#4E4C4C'/> </svg>"},e.freehandInterval=3,e.interactionType=DrawingInteractionType.hybrid,e.mode=DrawingMode.idle,e.secondaryDragHandleStyle={anchor:"center",draggable:!0,htmlContent:"<svg width='12' height='12' viewBox='0 0 12 12' fill='none' xmlns='http://www.w3.org/2000/svg'> <circle class='dragHandleCircle' cx = '6' cy = '6' r = '5.5' fill='#A6A6A6' stroke='#4E4C4C'/> </svg>"},e.shapeDraggingEnabled=!0,e.shapeRotationEnabled=!0,e.source=void 0,e.toolbar=void 0,e}return __extends(e,t),e._cloneCustomizer=function(e){if(e instanceof DrawingToolbar||e instanceof azmaps.source.DataSource||e instanceof PropertyEditorDialog)return e},e}(Options),DrawingHelper=function(){function e(e,t){var a=this;this.options={},this.strokeColor="#2266E3",this.parentIdProp="parent_id",this.outlineProp="outline",this.addCoord=function(e,t){a.options.mode===DrawingMode.drawPoint&&(a.finalShape=new azmaps.Shape(new azmaps.data.Point([])),a.activeShape=new azmaps.Shape(new azmaps.data.Point(e.position)),a.activeShape.addProperty(a.parentIdProp,a.finalShape.getId()),a.drawMgr._invokeEvent("drawingstarted",null),a.finish()),a.options.mode!==DrawingMode.drawLine&&a.options.mode!==DrawingMode.drawPolygon||("click"!==e.type&&!t||a.options.interactionType!==DrawingInteractionType.click&&a.options.interactionType!==DrawingInteractionType.hybrid?!a.isMouseDown||"mousemove"!==e.type&&"touchmove"!==e.type||a.options.interactionType!==DrawingInteractionType.freehand&&a.options.interactionType!==DrawingInteractionType.hybrid||(a.previewShape&&(a.previewSource.remove(a.previewShape),a.previewShape=null,a.previewShapeCoordinates=[]),a.activeShape||(a.activeShape=new azmaps.Shape(new azmaps.data.LineString([])),a.options.mode===DrawingMode.drawPolygon?(a.finalShape=new azmaps.Shape(new azmaps.data.Polygon([])),a.activeShape.addProperty(a.outlineProp,!0)):a.finalShape=new azmaps.Shape(new azmaps.data.LineString([])),a.activeShape.addProperty(a.parentIdProp,a.finalShape.getId()),a.options.source.add(a.activeShape)),t=a.map.positionsToPixels(a.activeShapeCoordinates)[0],(0===a.activeShapeCoordinates.length||a.pixelDifference(t,e.pixel)>a.options.freehandInterval)&&a.updateActiveShape(e)):(a.activeShape||(a.activeShape=new azmaps.Shape(new azmaps.data.LineString([])),a.options.mode===DrawingMode.drawPolygon?(a.finalShape=new azmaps.Shape(new azmaps.data.Polygon([])),a.activeShape.addProperty(a.outlineProp,!0)):a.finalShape=new azmaps.Shape(new azmaps.data.LineString([])),a.activeShape.addProperty(a.parentIdProp,a.finalShape.getId()),a.options.source.add(a.activeShape)),a.previewShape||a.updateActiveShape(e),a.previewShape&&(a.activeShapeCoordinates.push(e.position),a.activeShape.setCoordinates(a.activeShapeCoordinates),a.drawMgr._invokeEvent("drawingchanged",a.activeShape),a.previewSource.remove(a.previewShape),a.previewShape=null,a.previewShapeCoordinates=[]))),a.options.mode===DrawingMode.drawRectangle&&(!a.isMouseDown||"mousemove"!==e.type&&"touchmove"!==e.type||(a.activeShape?(a.activeShapeCoordinates=[a.firstRectangleCorner,[e.position[0],a.firstRectangleCorner[1]],e.position,[a.firstRectangleCorner[0],e.position[1]],a.firstRectangleCorner],a.activeShape.setCoordinates(a.activeShapeCoordinates),a.drawMgr._invokeEvent("drawingchanging",a.activeShape)):(a.finalShape=new azmaps.Shape(new azmaps.data.Polygon([])),a.activeShape=new azmaps.Shape(new azmaps.data.Polygon([])),a.activeShape.addProperty(a.parentIdProp,a.finalShape.getId()),a.activeShape.addProperty("subType","Rectangle"),a.options.source.add(a.activeShape),a.firstRectangleCorner=e.position,a.drawMgr._invokeEvent("drawingstarted",null)))),a.options.mode===DrawingMode.drawCircle&&(!a.isMouseDown||"mousemove"!==e.type&&"touchmove"!==e.type||(a.activeShape?(a.activeShape.addProperty("radius",azmaps.math.getDistanceTo(a.circleCenterPosition,e.position)),a.drawMgr._invokeEvent("drawingchanging",a.activeShape)):(a.finalShape=new azmaps.Shape(new azmaps.data.Point([])),a.activeShape=new azmaps.Shape(new azmaps.data.Point(e.position)),a.activeShape.addProperty(a.parentIdProp,a.finalShape.getId()),a.activeShape.addProperty("subType","Circle"),a.activeShape.addProperty("radius",1),a.options.source.add(a.activeShape),a.circleCenterPosition=e.position,a.drawMgr._invokeEvent("drawingstarted",null))))},this.previewCoord=function(e){a.isMouseDown||!a.activeShape||a.options.mode!==DrawingMode.drawLine&&a.options.mode!==DrawingMode.drawPolygon||a.options.interactionType!==DrawingInteractionType.click&&a.options.interactionType!==DrawingInteractionType.hybrid||(a.previewShape||(a.previewShapeCoordinates=[a.activeShapeCoordinates[a.activeShapeCoordinates.length-1]],a.previewShape=new azmaps.Shape(new azmaps.data.LineString(a.previewShapeCoordinates)),a.previewSource.add(a.previewShape)),a.previewShapeCoordinates[1]=e.position,a.previewShape.setCoordinates(a.previewShapeCoordinates),e=__spreadArrays(a.activeShapeCoordinates,[e.position]),(e=new azmaps.Shape(new azmaps.data.LineString(e))).addProperty(a.parentIdProp,a.finalShape.getId()),a.drawMgr._invokeEvent("drawingchanging",e))},this.finish=function(e){e&&e.preventDefault();var t=!1;a.activeShape&&(a.options.mode!==DrawingMode.drawCircle&&a.options.mode!==DrawingMode.drawRectangle||a.drawMgr._invokeEvent("drawingchanged",a.activeShape),a.options.mode===DrawingMode.drawPolygon?0<a.activeShapeCoordinates.length&&(a.activeShapeCoordinates.push(a.activeShapeCoordinates[0]),a.finalShape.setCoordinates(a.activeShapeCoordinates)):a.finalShape.setCoordinates(a.activeShape.getCoordinates()),delete(e=a.activeShape.getProperties())[a.parentIdProp],delete e[a.outlineProp],a.options.source.getShapeById(a.activeShape.getId())&&a.options.source.remove(a.activeShape),a.finalShape.setProperties(e),a.options.source.add(a.finalShape),t=!(a.activeShape=null)),a.activeShapeCoordinates=[],a.previewShape&&a.previewSource.remove(a.previewShape),a.previewShapeCoordinates=[],a.previewShape=null,a.isMouseDown=!1,t&&(t=!1,a.drawMgr._invokeEvent("drawingcomplete",a.finalShape))},this.cancel=function(){a.activeShape&&(a.options.source.remove(a.activeShape),a.activeShapeCoordinates=[],a.activeShape=null,a.previewShape&&(a.previewSource.remove(a.previewShape),a.previewShapeCoordinates=[],a.previewShape=null),a.isMouseDown=!1)},this.setMouseDown=function(){a.isMouseDown=!0},this.setMouseUp=function(){a.isMouseDown=!1,a.options.interactionType===DrawingInteractionType.freehand&&a.finish()},this.getPreviewLayers=function(){return a.previewLayers},this.drawMgr=t,this.map=e,this.previewLayers=new DrawingLayers,this.previewSource=new azmaps.source.DataSource,this.map.sources.add(this.previewSource),this.previewLayers.pointLayer=new azmaps.layer.SymbolLayer(this.previewSource,null,{filter:["==",["geometry-type"],"Point"]}),this.previewLayers.lineLayer=new azmaps.layer.LineLayer(this.previewSource,null,{filter:["all",["==",["geometry-type"],"LineString"],["!",["has",this.outlineProp]]],strokeColor:this.strokeColor}),this.previewLayers.polygonLayer=new azmaps.layer.PolygonLayer(this.previewSource,null,{filter:["==",["geometry-type"],"Polygon"],strokeColor:this.strokeColor}),this.previewLayers.polygonOutlineLayer=new azmaps.layer.LineLayer(this.previewSource,null,{filter:["all",["==",["geometry-type"],"LineString"],["has",this.outlineProp]],strokeColor:this.strokeColor}),this.map.layers.add([this.previewLayers.polygonLayer,this.previewLayers.polygonOutlineLayer,this.previewLayers.lineLayer,this.previewLayers.pointLayer]),this.activeShapeCoordinates=[],this.previewShapeCoordinates=[]}return e.prototype.dispose=function(){this.previewLayers&&(this.map.layers.remove(this.previewLayers.lineLayer),this.map.layers.remove(this.previewLayers.polygonLayer),this.map.layers.remove(this.previewLayers.polygonOutlineLayer),this.map.layers.remove(this.previewLayers.pointLayer)),this.map=null,this.options=null,this.previewLayers=null},e.prototype.setOptions=function(e){this.options.mode!==e.mode&&this.finish(),this.options=e},e.prototype.pixelDifference=function(e,t){var a=e[0]-t[0],t=e[1]-t[1];return Math.sqrt(a*a+t*t)},e.prototype.updateActiveShape=function(e){var t=this.activeShapeCoordinates[this.activeShapeCoordinates.length-1];0<this.activeShapeCoordinates.length?t[0]===e.position[0]&&t[1]===e.position[1]||(this.activeShapeCoordinates.push(e.position),this.activeShape.setCoordinates(this.activeShapeCoordinates),this.drawMgr._invokeEvent("drawingchanged",this.activeShape)):(this.activeShapeCoordinates.push(e.position),this.activeShape.setCoordinates(this.activeShapeCoordinates),this.drawMgr._invokeEvent("drawingstarted",null))},e}();!function(e){e.primary="primary",e.secondary="secondary",e.rotational="rotational"}(HandleType=HandleType||{});var DragHandle=function(n){function e(e,t,a,s,o,r){var i=n.call(this,e)||this;return i.promoteHandle=function(e){i.getHandleType()===HandleType.secondary&&i.editHelper.promoteHandle(i,i.index,e)},i.moveHandle=function(){i.editHelper.moveHandle(i,i.index)},i.showHandles=function(){i.getHandleType()===HandleType.primary&&i.editHelper.showHandles(i,i.index)},i.primaryHtmlContent=r.dragHandleStyle.htmlContent,i.secondaryHtmlContent=r.secondaryDragHandleStyle.htmlContent,i.mp=t,i.editHelper=a,i.handleType=s,i.index=o,i.mp.events.add("dragend",i,i.promoteHandle),i.mp.events.add("dragend",i,i.showHandles),i.mp.events.add("drag",i,i.moveHandle),i}return __extends(e,n),e.prototype.setStyle=function(e){this.style=e,this.setOptions(this.style)},e.prototype.setState=function(e){this.handleType=e,this.handleType===HandleType.primary?this.setOptions({htmlContent:this.primaryHtmlContent}):this.handleType===HandleType.secondary&&this.setOptions({htmlContent:this.secondaryHtmlContent})},e.prototype.setIndex=function(e){this.index=e},e.prototype.setPosition=function(e){this.setOptions({position:e})},e.prototype.getPosition=function(){return this.getOptions().position},e.prototype.getHandleType=function(){return this.handleType},e.prototype.getIndex=function(){return this.index},e}(azmaps.HtmlMarker),MapInputHelper=function(){function t(e,t,a,s,o){var r=this;this.options={},this.trackMousePosition=function(e){r.mouseEvent=e},this.fKeyPressed=function(e){70!==e.keyCode&&102!==e.keyCode||r.drawingHelper.addCoord(r.mouseEvent,!0)},this.cKeyPressed=function(e){67!==e.keyCode&&99!==e.keyCode||(r.drawingHelper.finish(),r.editHelper.finish())},this.deleteKeyPressed=function(e){46!==e.keyCode&&8!==e.keyCode||r.editHelper.erase()},this.escKeyPressed=function(e){27===e.keyCode&&(r.drawingHelper.cancel(),r.editHelper.finish())},this.setMouseCursorToMove=function(){r.map.getCanvas().style.cursor="move"},this.setMouseCursorToPointer=function(){r.map.getCanvas().style.cursor="default"},this.setMouseCursorToCrossHair=function(){r.map.getCanvas().style.cursor="crosshair"},this.setMouseCursorToGrab=function(){r.map.getCanvas().style.cursor="grab"},this.map=e,this.layers=a,this.editHelper=o,this.drawingHelper=s,this.setOptions(this.options)}return t.prototype.setOptions=function(e){if(this.options.mode!==e.mode||this.options.freehandInterval!==e.freehandInterval||this.options.interactionType!==e.interactionType)switch(this.options=e,this.options.mode===DrawingMode.editGeometry&&this.options.shapeDraggingEnabled?(this.map.events.remove("mouseover",Object.values(this.layers),this.setMouseCursorToPointer),this.map.events.remove("mouseout",Object.values(this.layers),this.setMouseCursorToGrab),this.map.events.add("mouseover",Object.values(this.layers),this.setMouseCursorToMove),this.map.events.add("mouseout",Object.values(this.layers),this.setMouseCursorToGrab)):this.options.mode===DrawingMode.eraseGeometry?(this.map.events.remove("mouseover",Object.values(this.layers),this.setMouseCursorToMove),this.map.events.remove("mouseout",Object.values(this.layers),this.setMouseCursorToGrab),this.map.events.add("mouseover",Object.values(this.layers),this.setMouseCursorToPointer),this.map.events.add("mouseout",Object.values(this.layers),this.setMouseCursorToGrab)):(this.map.events.remove("mouseover",Object.values(this.layers),this.setMouseCursorToMove),this.map.events.remove("mouseover",Object.values(this.layers),this.setMouseCursorToPointer),this.map.events.remove("mouseout",Object.values(this.layers),this.setMouseCursorToGrab),this.options.mode===DrawingMode.idle?this.setMouseCursorToGrab():this.setMouseCursorToCrossHair()),this.options.mode){case DrawingMode.drawPoint:this._clear(),this.map.events.add("click",this.drawingHelper.addCoord),this.map.events.add("touchstart",this.drawingHelper.addCoord),this.map.events.add("mousemove",this.trackMousePosition),this.map.getMapContainer().addEventListener("keypress",this.fKeyPressed),this.map.getMapContainer().addEventListener("keypress",this.cKeyPressed),this.map.getMapContainer().addEventListener("keydown",this.escKeyPressed);break;case DrawingMode.drawLine:case DrawingMode.drawPolygon:this._clear(),t.lockMap(this.map),this.options.interactionType!==DrawingInteractionType.click&&this.options.interactionType!==DrawingInteractionType.hybrid||(this.map.events.add("click",this.drawingHelper.addCoord),this.map.events.add("mousemove",this.drawingHelper.previewCoord)),this.options.interactionType!==DrawingInteractionType.freehand&&this.options.interactionType!==DrawingInteractionType.hybrid||(this.map.events.add("mousedown",this.drawingHelper.setMouseDown),this.map.events.add("mousemove",this.drawingHelper.addCoord),this.map.events.add("mouseup",this.drawingHelper.setMouseUp),this.map.events.add("touchstart",this.drawingHelper.setMouseDown),this.map.events.add("touchmove",this.drawingHelper.addCoord),this.map.events.add("touchend",this.drawingHelper.finish)),this.map.events.add("dblclick",this.drawingHelper.finish),this.map.events.add("mousemove",this.trackMousePosition),this.map.getMapContainer().addEventListener("keypress",this.fKeyPressed),this.map.getMapContainer().addEventListener("keypress",this.cKeyPressed),this.map.getMapContainer().addEventListener("keydown",this.escKeyPressed);break;case DrawingMode.drawCircle:case DrawingMode.drawRectangle:this._clear(),t.lockMap(this.map),this.map.events.add("mousedown",this.drawingHelper.setMouseDown),this.map.events.add("mousemove",this.drawingHelper.addCoord),this.map.events.add("mouseup",this.drawingHelper.finish),this.map.events.add("touchstart",this.drawingHelper.setMouseDown),this.map.events.add("touchmove",this.drawingHelper.addCoord),this.map.events.add("touchend",this.drawingHelper.finish),this.map.events.add("mousemove",this.trackMousePosition),this.map.getMapContainer().addEventListener("keypress",this.fKeyPressed),this.map.getMapContainer().addEventListener("keypress",this.cKeyPressed),this.map.getMapContainer().addEventListener("keydown",this.escKeyPressed);break;case DrawingMode.editGeometry:t.unLockMap(this.map),this.map.events.add("click",this.editHelper.selectShape),this.map.events.add("touchstart",this.editHelper.selectShape),this.map.events.add("mousedown",this.editHelper.setMouseDown),this.map.events.add("mouseup",this.editHelper.setMouseUp),this.map.events.add("touchstart",this.editHelper.setMouseDown),this.map.events.add("touchend",this.editHelper.setMouseUp),this.map.getMapContainer().addEventListener("keydown",this.escKeyPressed),this.map.getMapContainer().addEventListener("keydown",this.deleteKeyPressed);break;case DrawingMode.eraseGeometry:t.unLockMap(this.map),this.map.events.add("click",this.editHelper.selectShape),this.map.events.add("touchstart",this.editHelper.selectShape),this.map.events.add("mousedown",this.editHelper.setMouseDown),this.map.events.add("mouseup",this.editHelper.setMouseUp),this.map.events.add("touchstart",this.editHelper.setMouseDown),this.map.events.add("touchend",this.editHelper.setMouseUp),this.map.getMapContainer().addEventListener("keydown",this.deleteKeyPressed);break;default:t.unLockMap(this.map),this._clear()}},t.prototype._clear=function(){this.drawingHelper.finish(),this.editHelper.finish(),this.map.events.remove("click",this.drawingHelper.addCoord),this.map.events.remove("touchstart",this.drawingHelper.addCoord),this.map.events.remove("drag",this.drawingHelper.addCoord),this.map.events.remove("mousemove",this.drawingHelper.previewCoord),this.map.events.remove("mousemove",this.drawingHelper.addCoord),this.map.events.remove("mouseup",this.drawingHelper.finish),this.map.events.remove("mouseup",this.drawingHelper.addCoord),this.map.events.remove("mouseup",this.drawingHelper.setMouseUp),this.map.events.remove("mousedown",this.drawingHelper.setMouseDown),this.map.events.remove("dblclick",this.drawingHelper.finish),this.map.events.remove("mousemove",this.trackMousePosition),this.map.events.remove("touchstart",this.drawingHelper.setMouseDown),this.map.events.remove("touchmove",this.drawingHelper.addCoord),this.map.events.remove("touchend",this.drawingHelper.finish),this.map.events.remove("click",this.editHelper.selectShape),this.map.events.remove("touchstart",this.editHelper.selectShape),this.map.events.remove("mousedown",this.editHelper.setMouseDown),this.map.events.remove("mouseup",this.editHelper.setMouseUp),this.map.events.remove("touchstart",this.editHelper.setMouseDown),this.map.events.remove("touchend",this.editHelper.setMouseUp),this.map.getMapContainer().removeEventListener("keypress",this.fKeyPressed),this.map.getMapContainer().removeEventListener("keypress",this.cKeyPressed),this.map.getMapContainer().removeEventListener("keydown",this.deleteKeyPressed),this.map.getMapContainer().removeEventListener("keydown",this.escKeyPressed)},t.lockMap=function(e){e.setUserInteraction({dblClickZoomInteraction:!1,dragPanInteraction:!1}),e.getMapContainer().style.touchAction="none"},t.unLockMap=function(e){e.setUserInteraction({dblClickZoomInteraction:!0,dragPanInteraction:!0}),e.getMapContainer().style.touchAction=null},t}(),EditHelper=function(){function e(e,t,a,s){var o=this;this.editedPointStyle="marker-blue",this.isDragging=!1,this.erase=function(){o.shape&&(o.options.source.remove(o.shape),o.selectedShapeCoordinates=[],o._clearHandlesAndListeners(),o.drawMgr._invokeEvent("drawingerased",o.shape),o.shape=null,o.isMouseDown=!1)},this.selectShape=function(e){var t,a;e.originalEvent.target===o.map.getCanvas()&&(t=[e.pixel[0]-3,e.pixel[1]+3],a=[e.pixel[0]+3,e.pixel[1]-3],t=o.map.pixelsToPositions([t])[0],a=o.map.pixelsToPositions([a])[0],a=new azmaps.data.BoundingBox(t,a),(a=o.map.layers.getRenderedShapes(a,Object.values(o.layers)))&&0<a.length&&((a=a[0])&&(o.options.mode===DrawingMode.eraseGeometry?(o.shape=a,o.erase(),o.drawMgr.setOptions({mode:DrawingMode.idle})):o.edit(a))),e.originalEvent.stopImmediatePropagation())},this.setMouseDown=function(){o.isMouseDown=!0},this.setMouseUp=function(){o.isMouseDown=!1},this._startDragAndRotate=function(e){o.isEventShapeSameAsSelectedShape(e)&&(o.options.shapeDraggingEnabled&&(o.rotateHandle&&o.rotateHandle.setOptions({visible:!1}),o.isDragging=!0),o._freezeMap(o.shape,e))},this._dragAndRotate=function(e){if(o.shape&&o.isMouseDown){if(o.isDragging){var t=azmaps.Pixel.getX(o.currentReferencedPixel)-azmaps.Pixel.getX(e.pixel),a=azmaps.Pixel.getY(o.currentReferencedPixel)-azmaps.Pixel.getY(e.pixel);if(t*t+a*a<=25)return;o.map.markers.remove(o.primaryHandles),o.map.markers.remove(o.secondaryHandles),o.primaryHandles=[],o.secondaryHandles=[],o._pixelAccurateUpdate(e)}o.isRotating&&(e=o.map.positionsToPixels([o.initCentroid,e.position]),e=azmaps__default.Pixel.getHeading(e[0],e[1])-o.initHeading+180,o._showOrHideDragHandles(!1),o.rotateShape(o.shape,o.initCoordinates,o.initCentroid,e))}},this._endDragAndRotate=function(e){var t;MapInputHelper.unLockMap(o.map),o.isDragging&&(o.isDragging=!1,o.shape&&"Point"===o.shape.getType()&&!o.shape.isCircle()&&(delete(t=o.shape.getProperties())._azureMapsMarker,o.shape.setProperties(t)),o.rotateHandle&&o.rotateHandle.setOptions({visible:!0})),o.isRotating&&(o.isRotating=!1,o._showOrHideDragHandles(!0)),o.edit(o.shape)},this._handleMouseDownOnRotateHandle=function(e){var t=o.map.positionsToPixels([o.rotateInitHandlePosition,o.initCentroid]);o.initHeading=azmaps__default.Pixel.getHeading(t[0],t[1]),o.map.setUserInteraction({dragPanInteraction:!1}),o.isRotating=!0},this._startRotate=function(e){o._freezeMap(o.shape,e)},this.removeRotateHandle=function(){o.rotateHandle&&(o.map.events.remove("mousedown",o.rotateHandle,o._handleMouseDownOnRotateHandle),o.map.markers.remove(o.rotateHandle),o.rotateHandle=null)},this.map=e,this.options=t,this.primaryHandles=[],this.secondaryHandles=[],this.layers=a,this.drawMgr=s,this.defaultPointStyle=this.layers.pointLayer?this.layers.pointLayer.getOptions().iconOptions.image:"marker-black"}return e.prototype.setOptions=function(e){this.finish(),this.options=e},e.prototype.finish=function(){this._clearHandlesAndListeners();var e=this.shape;this.shape=null,e&&this.drawMgr._invokeEvent("drawingcomplete",e),this.currentReferencedPixel=null,MapInputHelper.unLockMap(this.map)},e.prototype.edit=function(e){this.shape&&this.drawMgr._invokeEvent("drawingcomplete",this.shape),this.drawMgr._invokeEvent("drawingstarted",e),this._disableShapeDragAndRotate(),this._clearHandlesAndListeners(),this.shape=e,this.selectedShapeCoordinates=this.shape.getCoordinates(),"Point"!==this.shape.getType()||this.shape.isCircle()?0===this.primaryHandles.length&&(this.shape.isCircle()?this._generateDragHandles(this.selectedShapeCoordinates):this.shape.isRectangle()?this._generateDragHandles(this.selectedShapeCoordinates[0]):"LineString"===this.shape.getType()?this._generateDragHandles(this.selectedShapeCoordinates):"Polygon"===this.shape.getType()&&this._generateDragHandles(this.selectedShapeCoordinates[0])):this.shape.addProperty("_azureMapsMarker",this.editedPointStyle),this._enableShapeDragAndRotate()},e.prototype.promoteHandle=function(e,t,a){this.isSecondaryHandleMoving=!1,e.setOptions({visible:!0});var s=e.getPosition(),o=this.primaryHandles.length;"LineString"===this.shape.getType()?n=(i=t)+1:"Polygon"===this.shape.getType()&&(i=0===t?o-1:t-1,n=t===o-1?0:t+1);var r,o=this.primaryHandles[i],i=this.primaryHandles[n],n=this._getMidPosition(s,o.getPosition()),o=this._getMidPosition(s,i.getPosition()),s=new DragHandle(this.options.secondaryDragHandleStyle,this.map,this,HandleType.secondary,t,this.options),i=new DragHandle(this.options.secondaryDragHandleStyle,this.map,this,HandleType.secondary,t+1,this.options);for(s.setPosition(n),i.setPosition(o),e.setState(HandleType.primary),e.setIndex(t+1),e.setStyle(this.options.dragHandleStyle),this.secondaryHandles[t]=s,this.secondaryHandles.splice(t+1,0,i),this.primaryHandles.splice(t+1,0,e),r=t+2;r<this.secondaryHandles.length;r++)this.primaryHandles[r].setIndex(r),this.secondaryHandles[r].setIndex(r);"LineString"===this.shape.getType()&&this.primaryHandles[r].setIndex(r),this.map.markers.add([s,i])},e.prototype.moveHandle=function(e,t){this.drawMgr._invokeEvent("drawingchanged",this.shape),this._disableShapeDragAndRotate();var a,s,o,r,i,n=e.getPosition();this.shape.isCircle()?(r=this.selectedShapeCoordinates,this.shape.setProperties({radius:azmaps.math.getDistanceTo(r,e.getPosition()),subType:"Circle"}),this.primaryHandles.forEach(function(e){e.setOptions({visible:!1})})):this.shape.isRectangle()?(e.setOptions({visible:!1}),s=a=void 0,(i=this.selectedShapeCoordinates[0])[t]=n,s=0===t?(a=this.primaryHandles.length-1,t+1):(a=t-1,t===this.primaryHandles.length-1?0:t+1),o=this.primaryHandles[a],r=this.primaryHandles[s],0===t||2===t?(i[a][0]=n[0],i[s][1]=n[1]):1!==t&&3!==t||(i[a][1]=n[1],i[s][0]=n[0]),o.setPosition(i[a]),r.setPosition(i[s]),o.setOptions({visible:!1}),r.setOptions({visible:!1}),i[i.length-1]=i[0],this.shape.setCoordinates([i])):"LineString"===this.shape.getType()?(e.setOptions({visible:!1}),e.getHandleType()===HandleType.primary&&((i=this.selectedShapeCoordinates)[t]=n,this.shape.setCoordinates(i),0<t&&this.secondaryHandles[t-1].setOptions({visible:!1}),t<this.primaryHandles.length-1&&this.secondaryHandles[t].setOptions({visible:!1})),e.getHandleType()===HandleType.secondary&&(i=this.selectedShapeCoordinates,this.isSecondaryHandleMoving?i[t+1]=n:(i.splice(t+1,0,n),this.isSecondaryHandleMoving=!0),this.shape.setCoordinates(i))):"Polygon"===this.shape.getType()&&(e.setOptions({visible:!1}),e.getHandleType()===HandleType.primary&&((i=this.selectedShapeCoordinates[0])[t]=n,0===t?(this.secondaryHandles[t].setOptions({visible:!1}),this.secondaryHandles[this.secondaryHandles.length-1].setOptions({visible:!1})):(0<t&&this.secondaryHandles[t-1].setOptions({visible:!1}),t<this.primaryHandles.length&&this.secondaryHandles[t].setOptions({visible:!1})),i[i.length-1]=i[0],this.shape.setCoordinates([i])),e.getHandleType()===HandleType.secondary&&(i=this.selectedShapeCoordinates[0],this.isSecondaryHandleMoving?i[t+1]=n:(i.splice(t+1,0,n),this.isSecondaryHandleMoving=!0),this.shape.setCoordinates([i])))},e.prototype.showHandles=function(e,t){var a,s,o,r,i,n,p,l,d;this.shape.isCircle()?(a=this.selectedShapeCoordinates,s=this.shape.getProperties().radius,o=0,this.primaryHandles.forEach(function(e){e.setPosition(azmaps.math.getDestination(a,o+=90,s)),e.setOptions({visible:!0})})):(r=e.getPosition(),i=this.primaryHandles.length,d=p=l=n=void 0,"LineString"===this.shape.getType()?(n=0<t?t-1:null,l=t<i-1?t+1:null,p=t-1,d=t):"Polygon"===this.shape.getType()&&(l=t===i-1?0:t+1,p=n=0===t?i-1:t-1,d=t),null!=n&&(n=this.primaryHandles[n],this.shape.isRectangle()?n.setOptions({visible:!0}):(n=this._getMidPosition(r,n.getPosition()),(p=this.secondaryHandles[p]).setPosition(n),this.map.markers.add(p),p.setOptions({visible:!0}))),null!=l&&(l=this.primaryHandles[l],this.shape.isRectangle()?l.setOptions({visible:!0}):(l=this._getMidPosition(r,l.getPosition()),(d=this.secondaryHandles[d]).setPosition(l),this.map.markers.add(d),d.setOptions({visible:!0})))),e.setOptions({visible:!0}),this._enableShapeDragAndRotate()},e.prototype._generateDragHandles=function(e){if(this.shape.isCircle())for(var t=e,a=this.shape.getProperties().radius,s=0,o=0;o<4;o++){var r=azmaps.math.getDestination(t,s+=90,a);(i=new DragHandle(this.options.dragHandleStyle,this.map,this,HandleType.primary,o,this.options)).setPosition(r),this.map.markers.add(i),this.primaryHandles.push(i)}else{for(var i,n,p,o=0;o<e.length;o++)(i=new DragHandle(this.options.dragHandleStyle,this.map,this,HandleType.primary,o,this.options)).setPosition(e[o]),this.primaryHandles.push(i),this.map.markers.add(i),this.shape.isRectangle()||o<e.length-1&&(n=this._getMidPosition(e[o],e[o+1]),(p=new DragHandle(this.options.secondaryDragHandleStyle,this.map,this,HandleType.secondary,o,this.options)).setPosition(n),this.map.markers.add(p),this.secondaryHandles.push(p));"Polygon"===this.shape.getType()&&this.map.markers.remove(this.primaryHandles.pop())}},e.prototype._getMidPosition=function(e,t){e=this.map.positionsToPixels([e])[0],t=this.map.positionsToPixels([t])[0],t=[(e[0]+t[0])/2,(e[1]+t[1])/2];return this.map.pixelsToPositions([t])[0]},e.prototype._clearHandlesAndListeners=function(){this.map.markers.remove(this.primaryHandles),this.map.markers.remove(this.secondaryHandles),this.primaryHandles=[],this.secondaryHandles=[],this._disableShapeDragAndRotate(),this.removeRotateHandle(),this.shape&&"Point"===this.shape.getType()&&!this.shape.isCircle()&&this.shape.addProperty("_azureMapsMarker",this.defaultPointStyle)},e.prototype._enableShapeDragAndRotate=function(){this._dragOrRotateEnabled()&&(this.map.events.add("mousedown",this._startDragAndRotate),this.map.events.add("mousemove",this._dragAndRotate),this.map.events.add("mouseup",this._endDragAndRotate),this._shouldRotate()&&(this._unselectShapeForRotate(),this.initCentroid=azmaps__default.data.BoundingBox.getCenter(azmaps__default.data.BoundingBox.fromData(this.shape)),this.initCoordinates=this.shape.getCoordinates(),this.initHeading=null,this.rotateInitHandlePosition=this.getInitHandlePosition(this.shape),this.rotateHandle=new azmaps.HtmlMarker({position:this.rotateInitHandlePosition,htmlContent:'<div class="rotateHandleIcon" />'}),this.map.markers.add(this.rotateHandle),this.map.events.add("mousedown",this.rotateHandle,this._handleMouseDownOnRotateHandle)))},e.prototype._dragOrRotateEnabled=function(){return this.options&&(this.options.shapeDraggingEnabled||this.options.shapeRotationEnabled)},e.prototype._shouldRotate=function(){return this.options&&this.options.shapeRotationEnabled&&"Point"!==this.shape.getType()&&!this.shape.isCircle()},e.prototype._disableShapeDragAndRotate=function(){this._dragOrRotateEnabled()&&(this.map.events.remove("mousedown",this._startDragAndRotate),this.map.events.remove("mousemove",this._dragAndRotate),this.map.events.remove("mouseup",this._endDragAndRotate))},e.prototype.isEventShapeSameAsSelectedShape=function(e){var t,e=e.shapes&&e.shapes.filter(function(e){return e&&e.getProperties});return(t=e&&0<e.length?e[0]:t)&&this.shape&&this.shape.getId()===t.getId()},e.prototype._freezeMap=function(e,t){this.shape=e,MapInputHelper.lockMap(this.map),this.currentReferencedPixel=t.pixel},e.prototype._pixelAccurateUpdate=function(e){var t=azmaps.Pixel.getX(this.currentReferencedPixel)-azmaps.Pixel.getX(e.pixel),a=azmaps.Pixel.getY(this.currentReferencedPixel)-azmaps.Pixel.getY(e.pixel);if("Point"===this.shape.getType()){var s=this.shape.getCoordinates();this.shape.setCoordinates(this._pixelShiftLocations(s,t,a))}else{var o=void 0;"Polygon"===this.shape.getType()?o=this.shape.getCoordinates()[0]:"LineString"===this.shape.getType()&&(o=this.shape.getCoordinates());for(var r=0,i=o.length;r<i;r++)o[r]=this._pixelShiftLocations(o[r],t,a);this.shape.setCoordinates(o)}this.currentReferencedPixel=e.pixel},e.prototype._pixelShiftLocations=function(e,t,a){e=this.map.positionsToPixels([e])[0];return e[0]-=t,e[1]-=a,this.map.pixelsToPositions([e])[0]},e.prototype._showOrHideDragHandles=function(t){this.primaryHandles.forEach(function(e){e.setOptions({visible:t})}),this.secondaryHandles.forEach(function(e){e.setOptions({visible:t})})},e.prototype._unselectShapeForRotate=function(){this.initCentroid=null,this.initCoordinates=null,this.initHeading=null,this.isRotating=!1,this.removeRotateHandle()},e.prototype.rotateShape=function(e,t,a,s){switch(e.getType()){case"LineString":case"MultiPoint":e.setCoordinates(azmaps.math.rotatePositions(t,a,s));break;case"Polygon":case"MultiLineString":var o=t.map(function(e){return azmaps.math.rotatePositions(e,a,s)});e.setCoordinates(o);break;case"MultiPolygon":o=t.map(function(e){return e.map(function(e){return azmaps.math.rotatePositions(e,a,s)})});e.setCoordinates(o)}this.rotateHandle&&this.rotateHandle.setOptions({position:azmaps.math.rotatePositions([this.rotateInitHandlePosition],a,s)[0]})},e.prototype.getInitHandlePosition=function(e){e=e.getCoordinates();return azmaps.math.getPositions(e)[0]},e}(),DrawingManager=function(s){function e(e,t){var a=s.call(this)||this;return a.map=e,a.options=(new DrawingManagerOptions).merge(cloneDeepWith_1(t,DrawingManagerOptions._cloneCustomizer)),a.drawingLayers=new DrawingLayers,a.drawingHelper=new DrawingHelper(a.map,a),a.editHelper=new EditHelper(a.map,t,a.drawingLayers,a),a.inputHelper=new MapInputHelper(a.map,a.options,a.drawingLayers,a.drawingHelper,a.editHelper),a.setOptions(a.options),a}return __extends(e,s),e.prototype.dispose=function(){this.options.toolbar&&this.options.toolbar._dispose(),this.drawingLayers&&(this.map.layers.remove(this.drawingLayers.lineLayer),this.map.layers.remove(this.drawingLayers.polygonLayer),this.map.layers.remove(this.drawingLayers.polygonOutlineLayer),this.map.layers.remove(this.drawingLayers.pointLayer)),this.drawingHelper&&this.drawingHelper.dispose(),this.map=null,this.options=null,this.drawingLayers=null,this.source=null,this.drawingHelper=null,this.editHelper=null,this.inputHelper=null},e.prototype.edit=function(e){e&&(this.source&&!this.source.getShapeById(e.getId())&&this.source.add(e),this.setOptions({mode:DrawingMode.editGeometry}),this.editHelper.edit(e))},e.prototype.getOptions=function(){return this.options},e.prototype.getLayers=function(){return this.drawingLayers},e.prototype.getPreviewLayers=function(){return this.drawingHelper.getPreviewLayers()},e.prototype.getSource=function(){return this.source},e.prototype.setOptions=function(e){e=(new DrawingManagerOptions).merge(this.options,cloneDeepWith_1(e,DrawingManagerOptions._cloneCustomizer));e.dragHandleStyle.draggable=!0,e.secondaryDragHandleStyle.draggable=!0,e.source=e.source||this.options.source,this.options.toolbar!==e.toolbar?(this.options.toolbar&&this.options.toolbar._close(),this.options.toolbar=e.toolbar,this.options.toolbar&&this.options.toolbar._open(this,this.map)):this.options.toolbar&&!this.options.toolbar._isOpen()&&this.options.toolbar._open(this,this.map),this.options.source?this.options.source!==e.source&&(this.source=this.options.source,e.mode=DrawingMode.idle,this._setLayerSources()):(this.source=new azmaps.source.DataSource,this.map.sources.add(this.source),this._setLayerSources()),this.options.mode!==e.mode&&this._invokeEvent("drawingmodechanged",e.mode),this.options=e,this.options.source=this.source,this.editHelper.setOptions(this.options),this.inputHelper.setOptions(this.options),this.drawingHelper.setOptions(this.options),this.inputHelper.setOptions(this.options)},e.prototype._getMap=function(){return this.map},e.prototype._setLayerSources=function(){this.drawingLayers.polygonLayer?this.drawingLayers.polygonLayer.setOptions({filter:["==",["geometry-type"],"Polygon"],source:this.source}):(this.drawingLayers.polygonLayer=new azmaps.layer.PolygonLayer(this.source,null,{fillColor:"rgba(0, 0, 0, 0.12)",filter:["all",["==",["geometry-type"],"Polygon"],["!",["has","_incomplete"]]]}),this.map.layers.add(this.drawingLayers.polygonLayer)),this.drawingLayers.polygonOutlineLayer?this.drawingLayers.polygonOutlineLayer.setOptions({filter:["any",["==",["geometry-type"],"Polygon"],["all",["==",["geometry-type"],"LineString"],["has","_outline"]]],source:this.source}):(this.drawingLayers.polygonOutlineLayer=new azmaps.layer.LineLayer(this.source,null,{filter:["any",["==",["geometry-type"],"Polygon"],["all",["==",["geometry-type"],"LineString"],["has","_outline"]]],strokeColor:"#000000"}),this.map.layers.add(this.drawingLayers.polygonOutlineLayer)),this.drawingLayers.lineLayer?this.drawingLayers.lineLayer.setOptions({filter:["all",["==",["geometry-type"],"LineString"],["!",["has","_outline"]]],source:this.source}):(this.drawingLayers.lineLayer=new azmaps.layer.LineLayer(this.source,null,{filter:["all",["==",["geometry-type"],"LineString"],["!",["has","_outline"]]],strokeColor:"#000000"}),this.map.layers.add(this.drawingLayers.lineLayer)),this.drawingLayers.pointLayer?this.drawingLayers.pointLayer.setOptions({filter:["==",["geometry-type"],"Point"],source:this.source}):(this.drawingLayers.pointLayer=new azmaps.layer.SymbolLayer(this.source,null,{filter:["==",["geometry-type"],"Point"],iconOptions:{allowOverlap:!0,ignorePlacement:!0,image:["case",["has","_azureMapsMarker"],["get","_azureMapsMarker"],"marker-black"],size:.5}}),this.map.layers.add(this.drawingLayers.pointLayer))},e}(azmaps.internal.EventEmitter),SnapGridManager=function(){function e(e,t){var a=this;this._options={resolution:15,showGrid:!1,removeDuplicates:!0,enabled:!0,simplify:!0},this._mapSize24=512*Math.pow(2,24),this._updateGrid=function(){var p=a,e=p._map.getCamera(),t=Math.round(e.zoom),l=p._options.resolution*Math.pow(2,24-t),d=azmaps.data.BoundingBox,c=p._mapSize24,h=p.clip,e=a.splitOnAntimeridian(e.bounds),u=[];e.forEach(function(e){for(var t=p.fastPositionsToPixels([d.getNorthWest(e),d.getSouthEast(e)],!1,!1,l),e=t[0],t=t[1],a=h(e[0]-e[0]%l-l,0,c),s=h(t[0]-t[0]%l+l,0,c),o=h(e[1]-e[1]%l-l,0,c),r=h(t[1]-t[1]%l+l,0,c),i=o;i<r;i+=l)u.push(new azmaps.data.LineString(p.fastPixelsToPositions([[a,i],[s,i]])));for(var n=a;n<s;n+=l)u.push(new azmaps.data.LineString(p.fastPixelsToPositions([[n,o],[n,r]])))}),p._source.setShapes(u)};var s=this;s._map=e,s._source=new azmaps.source.DataSource,e.sources.add(s._source),s._layer=new azmaps.layer.LineLayer(s._source,null,{strokeColor:"#c3a77e",strokeWidth:1,visible:!1}),e.layers.add(s._layer,"transit"),s.setOptions(t||{})}return e.prototype.dispose=function(){var t=this;t._map.events.remove("move",t._updateGrid),t._map.events.remove("resize",t._updateGrid),Object.keys(t).forEach(function(e){t[e]=null})},e.prototype.getOptions=function(){return Object.assign({},this._options)},e.prototype.getGridLayer=function(){return this._layer},e.simplify=function(e,t){return azmaps.math.simplify(e,t)},e.prototype.snapPositions=function(e,t){var a=this._options;if(!a.enabled)return e;t="number"==typeof t?Math.round(Math.abs(t)):Math.round(this._map.getCamera().zoom);for(var s,o,r=a.resolution*Math.pow(2,24-t),i=this.fastPositionsToPixels(e,a.removeDuplicates,a.simplify,r),n=0,p=i.length;n<p;n++){.5*r<=(o=(s=i[n])[0]%r)&&(o-=r);var l=s[1]%r;.5*r<=l&&(l-=r),s[0]-=o,s[1]-=l}return this.fastPixelsToPositions(i)},e.prototype.snapShape=function(e,t){var a;this._options.enabled&&(e instanceof azmaps.Shape?(a=e.toJson(),this.snapFeature(a,t),e.setCoordinates(a.geometry.coordinates)):"Feature"===e.type&&this.snapFeature(e,t))},e.prototype.setOptions=function(e){var t,a,s,o;e&&(a=(t=this)._map,s=t._options,o=!1,"boolean"==typeof e.removeDuplicates&&e.removeDuplicates!==s.removeDuplicates&&(s.removeDuplicates=e.removeDuplicates),"boolean"==typeof e.simplify&&e.simplify!==s.simplify&&(s.simplify=e.simplify),"boolean"==typeof e.enabled&&e.enabled!==s.enabled&&(s.enabled=e.enabled),"number"==typeof e.resolution&&0<e.resolution&&(s.resolution=e.resolution,o=!0),"boolean"==typeof e.showGrid&&e.showGrid!==s.showGrid&&(s.showGrid=e.showGrid,s.showGrid?(a.events.add("move",t._updateGrid),a.events.add("resize",t._updateGrid),o=!0):(a.events.remove("move",t._updateGrid),a.events.remove("resize",t._updateGrid)),t._layer.setOptions({visible:s.showGrid})),o&&(t._source.clear(),t._updateGrid()))},e.prototype.snapFeature=function(e,t){var a=this,s=e.geometry;switch(s.type){case"Point":s.coordinates=a.snapPositions([s.coordinates],t)[0];break;case"LineString":case"MultiPoint":s.coordinates=a.snapPositions(s.coordinates,t);break;case"Polygon":case"MultiLineString":s.coordinates=s.coordinates.map(function(e){return a.snapPositions(e,t)});break;case"MultiPolygon":s.coordinates=s.coordinates.map(function(e){return e.map(function(e){return a.snapPositions(e,t)})})}},e.prototype.fastPositionsToPixels=function(e,t,a,s){for(var o,r,i=[],n=this._mapSize24,p=0,l=e.length;p<l;p++){var d=Math.sin(e[p][1]*Math.PI/180),c=Math.round((azmaps.math.normalizeLongitude(e[p][0])+180)/360*n),d=Math.round((.5-Math.log((1+d)/(1-d))/(4*Math.PI))*n);0!==p&&t&&o===c&&r===d||i.push([c,d]),o=c,r=d}return a&&1<i.length?azmaps.math.simplify(i,.5*s):i},e.prototype.fastPixelsToPositions=function(e){for(var t=[],a=0,s=e.length;a<s;a++)t.push(this.fastPixelToPosition(e[a]));return t},e.prototype.fastPixelToPosition=function(e){var t=this._mapSize24;return[360*(e[0]/t-.5),90-360*Math.atan(Math.exp(2*-(.5-e[1]/t)*Math.PI))/Math.PI]},e.prototype.clip=function(e,t,a){return Math.max(Math.min(e,a),t)},e.prototype.splitOnAntimeridian=function(e){var t,a,s,o,r,i,n=[];return 6<=e.length&&360<e[3]-e[0]?[[-180,e[1],e[2],180,e[4],e[5]]]:e.length<6&&360<e[2]-e[0]?[[-180,e[1],180,e[3]]]:(this.crossesAntimeridian(e)?(i=t=void 0,a=azmaps.math.normalizeLongitude(azmaps.data.BoundingBox.getWest(e)),s=azmaps.math.normalizeLongitude(azmaps.data.BoundingBox.getEast(e)),o=azmaps.math.normalizeLatitude(azmaps.data.BoundingBox.getNorth(e)),r=azmaps.math.normalizeLatitude(azmaps.data.BoundingBox.getSouth(e)),i=6<=e.length?(t=[a,r,e[2],180,o,e[5]],[-180,r,e[2],s,o,e[5]]):(t=[a,r,180,o],[-180,r,s,o]),n.push(t,i)):n.push(e),n)},e.prototype.crossesAntimeridian=function(e){return azmaps.math.normalizeLongitude(azmaps.data.BoundingBox.getEast(e))-azmaps.math.normalizeLongitude(azmaps.data.BoundingBox.getWest(e))<0||6<=e.length&&360<e[3]-e[0]||e.length<6&&360<e[2]-e[9]},e}(),snapGridInternal=Object.freeze({__proto__:null,SnapGridManager:SnapGridManager}),baseDrawing=Object.freeze({__proto__:null,DrawingManager:DrawingManager,get DrawingMode(){return DrawingMode},get DrawingInteractionType(){return DrawingInteractionType},SnapGridManager:SnapGridManager}),control=Namespace.merge("atlas.control",baseControl),drawing=Namespace.merge("atlas.drawing",baseDrawing),snapGrid=Namespace.merge("atlas.drawing",snapGridInternal);exports.control=control,exports.drawing=drawing,exports.snapGrid=snapGrid;
